(function() {
	var vkfox = {};
	const REQUEST_TIMEOUT_TIME = 30000;
	const MESSEGES_COUNT = 20;
	const POSTS_COUNT = 20;
	const OTHER_ITEM_COUNT = 3;
	const RETRY_TIME = 20000;
	const RELOG_TIME = 10000;
	const NOTIFY_PERIOD = 3000;
	const NOTIFICATION_TIMEOUT_TIME = 5000;
	const FADE_DEFAULT_DURATION = 100;
	const MAX_RETRIES_TO_START = 30;
	const YANDEX_HOMEPAGE_URL = "http://yandex.ru/?clid=149181";
	const YANDEX_SEARCH_URL = "http://yandex.ru/yandsearch?clid=149182&text=";
	const YANDEX_ADDRESSBAR_SEARCH_URL = "http://yandex.ru/yandsearch?clid=149185&text=";
	const MESSAGE_HISTORY_COUNT = 10;
    const MAX_NEWS_COUNT = 50;

	var makeDraggable = function(captureNode, movableNode) {
		var startX;
		var startY;
		movableNode.parentNode.style.position = 'relative';
		movableNode.style.position = 'absolute';
		var movableParentNodeWidth;
		var captureNodeWidth;
		var movableParentNodeHeight;
		var captureNodeHeight;
		var overlapDistance = 100;
		var mouseMoveHandler = function(event) {
			var dx = event.clientX - startX;
			var dy = event.clientY - startY;
			startX = event.clientX;
			startY = event.clientY;
			movableNode.style.left = Math.max( - overlapDistance, Math.min(movableParentNodeWidth - captureNodeWidth + overlapDistance, parseInt(movableNode.style.left) + dx)) + 'px';
			movableNode.style.top = Math.max(0, Math.min(movableParentNodeHeight - captureNodeHeight + overlapDistance, parseInt(movableNode.style.top) + dy)) + 'px';
		}
		var mouseUpHandler = function() {
			movableNode.className = movableNode.className.replace(/\s?pressed/ig, '');
			captureNode.ownerDocument.removeEventListener('mousemove', mouseMoveHandler, false);
			captureNode.ownerDocument.removeEventListener('mouseup', mouseUpHandler, false);
		}
		captureNode.onmousedown = function(event) {
			//calcilation are here, to be sure everything is defined, when move
			movableNode.style.left = parseInt(window.getComputedStyle(movableNode, null).left.replace('auto', '0'));
			movableNode.style.top = parseInt(window.getComputedStyle(movableNode, null).top.replace('auto', '0'));
			movableParentNodeWidth = movableNode.parentNode.offsetWidth;
			captureNodeWidth = captureNode.parentNode.offsetWidth;
			movableParentNodeHeight = movableNode.parentNode.offsetHeight;
			captureNodeHeight = captureNode.parentNode.offsetHeight;
			startX = event.clientX;
			startY = event.clientY;
			captureNode.ownerDocument.addEventListener('mouseup', mouseUpHandler, false);
			captureNode.ownerDocument.addEventListener('mousemove', mouseMoveHandler, false);
			movableNode.className += ' pressed';
			return false;
		}
	}

	function count(array) {
		var length = 0;
		for (var object in array) {
			length++;
		}
		return length;
	}
	//if JSON.parse throws error then try to eval and check that it's an object
	var parseJson = function(data, throwError) {
		self = vkfox;
		try {
			var response = JSON.parse(data);
		} catch(e) {
			try {
				var s = Components.utils.Sandbox("http://" + Storage.getPref('server'));
				response = Components.utils.evalInSandbox('(' + data + ')', s);
				if (typeof response != 'object') {
					if (throwError) {
						throw ('error.jsonNotAnObject : ' + e);
					} else {
						if (Storage.getPref('logErrors')) {
							log('error.jsonNotAnObject : ' + e + '; data : ' + data);
						}
					}
				}
			} catch(evalError) {
				if (throwError) {
					throw ('error.eval: ' + evalError);
				} else {
					if (Storage.getPref('logErrors')) {
						log('error.eval: ' + evalError + '; data : ' + data);
					}
				}
			}
		}
		return response;
	}
	var translit = (function() {
		var lat = new Array("jo", "zh", "i'", "ch", "sh", "xh", "je", "ju", "ja", "a", "b", "v", "g", "d", "e", "z", "i", "k", "l", "m", "n", "o", "p", "r", "s", "t", "u", "f", "x", "c", "'", "y", "`", "j", "h");
		var cyr = new Array("ё", "ж", "й", "ч", "ш", "щ", "э", "ю", "я", "а", "б", "в", "г", "д", "е", "з", "и", "к", "л", "м", "н", "о", "п", "р", "с", "т", "у", "ф", "х", "ц", "ь", "ы", "ъ", "ж", "х");
		//var latcap=new Array("JO","Jo","ZH","Zh","I'","Ch","CH","Sh","SH","Xh","XH","Je","JE","Ju","JU","Ja","JA","A","B","V","G","D","E","Z","I","K","L","M","N","O","P","R","S","T","U","F","X","C","Y","J","H");
		//var cyrcap=new Array("Ё","Ё","Ж","Ж","Й","Ч","Ч","Ш","Ш","Щ","Щ","Э","Э","Ю","Ю","Я","Я","А","Б","В","Г","Д","Е","З","И","К","Л","М","Н","О","П","Р","С","Т","У","Ф","Х","Ц","Ы","Ж","Х");
		var lat2cyrChar = {};
		var cyr2latChar = {};
		for (var i in lat) {
			lat2cyrChar[lat[i]] = cyr[i];
		}
		for (var i in cyr) {
			cyr2latChar[cyr[i]] = lat[i];
		}
		return {
			ru2en: function(input) {
				input = input.toLowerCase();
				var output = '';
				var i = 0;
				while (i < input.length) {
					if ((i < input.length - 1) && (typeof cyr2latChar[input.substr(i, 2)] != 'undefined')) {
						output += cyr2latChar[input.substr(i, 2)];
						i++;
					} else if (typeof cyr2latChar[input.charAt(i)] != 'undefined') {
						output += cyr2latChar[input.charAt(i)];
					} else {
						output += input.charAt(i);
					}
					i++;
				}
				return output;
			},
			en2ru: function(input) {
				input = input.toLowerCase();
				var output = '';
				var i = 0;
				while (i < input.length) {
					if ((i < input.length - 1) && (typeof lat2cyrChar[input.substr(i, 2)] != 'undefined')) {
						output += lat2cyrChar[input.substr(i, 2)];
						i++;
					} else if (typeof lat2cyrChar[input.charAt(i)] != 'undefined') {
						output += lat2cyrChar[input.charAt(i)];
					} else {
						output += input.charAt(i);
					}
					i++;
				}
				return output;
			}
		}
	})();
	/*
    *http://benalman.com/code/projects/javascript-linkify/docs/files/ba-linkify-js.html
    */
	var linkify = (function() {
		var
		SCHEME = "[a-z\\d.-]+://",
		IPV4 = "(?:(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])",
		HOSTNAME = "(?:(?:[^\\s!@#$%^&*()_=+[\\]{}\\\\|;:'\",.<>/?]+)\\.)+",
		TLD = "(?:ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)",
		HOST_OR_IP = "(?:" + HOSTNAME + TLD + "|" + IPV4 + ")",
		PATH = "(?:[;/][^#?<>\\s]*)?",
		QUERY_FRAG = "(?:\\?[^#<>\\s]*)?(?:#[^<>\\s]*)?",
		URI1 = "\\b" + SCHEME + "[^<>\\s]+",
		URI2 = "\\b" + HOST_OR_IP + PATH + QUERY_FRAG + "(?!\\w)",

		MAILTO = "mailto:",
		EMAIL = "(?:" + MAILTO + ")?[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@" + HOST_OR_IP + QUERY_FRAG + "(?!\\w)",

		URI_RE = new RegExp("(?:" + URI1 + "|" + URI2 + "|" + EMAIL + ")", "ig"),
		SCHEME_RE = new RegExp("^" + SCHEME, "i"),

		quotes = {
			"'": "`",
			'>': '<',
			')': '(',
			']': '[',
			'}': '{',
			'Â»': 'Â«',
			'âº': 'â¹'
		},

		default_options = {
			callback: function(text, href) {
				return href ? '<a href="' + href + '" title="' + href + '">' + text + '</a>': text;
			},
			punct_regexp: /(?:[!?.,:;'"]|(?:&|&amp;)(?:lt|gt|quot|apos|raquo|laquo|rsaquo|lsaquo);)$/
		};

		return function(txt, options) {
			options = options || {};
            txt = txt.replace(
                /\[(id\d+)\|(.+?)\]/g,
                "<a href='/$1'>$2</a>"
            );

			// Temp variables.
			var arr, i, link, href,

			// Output HTML.
			html = '',

			// Store text / link parts, in order, for re-combination.
			parts = [],

			// Used for keeping track of indices in the text.
			idx_prev,
			idx_last,
			idx,
			link_last,

			// Used for trimming trailing punctuation and quotes from links.
			matches_begin,
			matches_end,
			quote_begin,
			quote_end;

			// Initialize options.
			for (i in default_options) {
				if (options[i] === undefined) {
					options[i] = default_options[i];
				}
			}

			// Find links.
			while (arr = URI_RE.exec(txt)) {

				link = arr[0];
				idx_last = URI_RE.lastIndex;
				idx = idx_last - link.length;

				// Not a link if preceded by certain characters.
				if (/[\/:]/.test(txt.charAt(idx - 1))) {
					continue;
				}

				// Trim trailing punctuation.
				do {
					// If no changes are made, we don't want to loop forever!
					link_last = link;

					quote_end = link.substr( - 1)
					quote_begin = quotes[quote_end];

					// Ending quote character?
					if (quote_begin) {
						matches_begin = link.match(new RegExp('\\' + quote_begin + '(?!$)', 'g'));
						matches_end = link.match(new RegExp('\\' + quote_end, 'g'));

						// If quotes are unbalanced, remove trailing quote character.
						if ((matches_begin ? matches_begin.length: 0) < (matches_end ? matches_end.length: 0)) {
							link = link.substr(0, link.length - 1);
							idx_last--;
						}
					}

					// Ending non-quote punctuation character?
					if (options.punct_regexp) {
						link = link.replace(options.punct_regexp, function(a) {
							idx_last -= a.length;
							return '';
						});
					}
				} while (link.length && link !== link_last);

				href = link;

				// Add appropriate protocol to naked links.
				if (!SCHEME_RE.test(href)) {
					href = (href.indexOf('@') !== - 1 ? (!href.indexOf(MAILTO) ? '': MAILTO) : ! href.indexOf('irc.') ? 'irc://': ! href.indexOf('ftp.') ? 'ftp://': 'http://') + href;
				}

				// Push preceding non-link text onto the array.
				if (idx_prev != idx) {
					parts.push([txt.slice(idx_prev, idx)]);
					idx_prev = idx_last;
				}

				// Push massaged link onto the array
				parts.push([link, href]);
			};

			// Push remaining non-link text onto the array.
			parts.push([txt.substr(idx_prev)]);

			// Process the array items.
			for (i = 0; i < parts.length; i++) {
				html += options.callback.apply(window, parts[i]);
			}

			// In case of catastrophic failure, return the original text;
			return html || txt;
		};

	})();
	/*
    *hides real input and displays custom styled input
    */

    var styleCheckbox = function(node, checked) {
        hide(node);
        node.checked = checked;
        var customCheckbox = document.createElementNS("http://www.w3.org/1999/xhtml", 'html:div');
        if (checked) {
            customCheckbox.className = 'checkbox on';
        } else {
            customCheckbox.className = 'checkbox off';
        }
        customCheckbox.onclick = function() {
            if (/\s?on/.test(customCheckbox.className)) {
                customCheckbox.className = customCheckbox.className.replace(/\son\b/, ' off');
                node.checked = false;
            } else {
                customCheckbox.className = customCheckbox.className.replace(/\soff\b/, ' on');
                node.checked = true;
            }
            if (node.onclick) {
                node.onclick();
            }
        }
        node.parentNode.insertBefore(
        customCheckbox, node);
        return customCheckbox;
    }

    var styleRadiobutton = function(node, selected) {
        hide(node);
        node.selected = selected;
        var customRadiobutton = document.createElementNS("http://www.w3.org/1999/xhtml", 'html:div');
        if (selected) {
            customRadiobutton.className = 'radiobutton on';
        } else {
            customRadiobutton.className = 'radiobutton off';
        }
        customRadiobutton.onclick = (function(node) {
            return function() {
                //if (/\s?off/.test(customRadiobutton.className)) {
                    if (node.name) {
                        var radioButtonGroupNL = customRadiobutton.parentNode.parentNode.querySelectorAll('[name='+node.name+']');
                        for(var i = 0; i < radioButtonGroupNL.length; i++) {
                            if ( radioButtonGroupNL[i] != node ) {
                                radioButtonGroupNL[i].selected = false;
                                radioButtonGroupNL[i].parentNode.className = 'radiobutton off';
                                if ( radioButtonGroupNL[i].onchange ) {
                                    radioButtonGroupNL[i].onchange();
                                    //log('1');
                                }
                            }
                        }
                    }
                    customRadiobutton.className = customRadiobutton.className.replace(/\soff\b/, ' on');
                    node.selected = true;
                    if (node.onchange) {
                        node.onchange();
                        //log('2');
                    }
                //}
            }
        })(node);

        node.parentNode.querySelector('[for=' + node.id + ']').onclick = customRadiobutton.onclick;
        node.parentNode.insertBefore(
        customRadiobutton, node);
        customRadiobutton.appendChild(node);
        return customRadiobutton;
    }

	var makeDraggable = function(captureNode, movableNode) {
		var startX;
		var startY;
		movableNode.parentNode.style.position = 'relative';
		movableNode.style.position = 'absolute';
		var movableParentNodeWidth;
		var captureNodeWidth;
		var movableParentNodeHeight;
		var captureNodeHeight;
		var overlapDistance = 100;
		var mouseMoveHandler = function(event) {
			var dx = event.clientX - startX;
			var dy = event.clientY - startY;
			startX = event.clientX;
			startY = event.clientY;
			movableNode.style.left = Math.max( - overlapDistance, Math.min(movableParentNodeWidth - captureNodeWidth + overlapDistance, parseInt(movableNode.style.left) + dx)) + 'px';
			movableNode.style.top = Math.max(0, Math.min(movableParentNodeHeight - captureNodeHeight + overlapDistance, parseInt(movableNode.style.top) + dy)) + 'px';
		}
		var mouseUpHandler = function() {
			movableNode.className = movableNode.className.replace(/\s?pressed/ig, '');
			captureNode.ownerDocument.removeEventListener('mousemove', mouseMoveHandler, false);
			captureNode.ownerDocument.removeEventListener('mouseup', mouseUpHandler, false);
		}
		captureNode.onmousedown = function(event) {
			//calcilation are here, to be sure everything is defined, when move
			if (!movableNode.style.top) {
				movableNode.style.top = parseInt(window.getComputedStyle(movableNode, null).top.replace('auto', '0')) + 'px';
			}
			if (!movableNode.style.left) {
				movableNode.style.left = parseInt(window.getComputedStyle(movableNode, null).left.replace('auto', '0')) + 'px';
			}
			movableParentNodeWidth = movableNode.parentNode.offsetWidth;
			captureNodeWidth = captureNode.parentNode.offsetWidth;
			movableParentNodeHeight = movableNode.parentNode.offsetHeight;
			captureNodeHeight = captureNode.parentNode.offsetHeight;
			startX = event.clientX;
			startY = event.clientY;
			captureNode.ownerDocument.addEventListener('mouseup', mouseUpHandler, false);
			captureNode.ownerDocument.addEventListener('mousemove', mouseMoveHandler, false);
			movableNode.className += ' pressed';
			return false;
		}
	}
	/*
    *sliderize html tag
    */
	var makeSlider = function(node, value) {
		//document.onselectstart = function() {
			//return
			//false;
		//}
		if ((value < 0) || (isNaN(value)) || (typeof value == 'undefined')) {
			value = 0;
		}
		var sliderNode = node;
		var startX;
		var sliderNodeWidth = parseInt(window.getComputedStyle(sliderNode, null).width);
		var sliderParentNodeWidth = parseInt(window.getComputedStyle(sliderNode.parentNode, null).width);
		var userDefinedLeft = parseInt(window.getComputedStyle(sliderNode, null).left.replace('auto', '0'));
		sliderNode.parentNode.style.position = 'relative';
		sliderNode.style.position = 'absolute';
		sliderNode.style.left = Math.round(value * (sliderParentNodeWidth - sliderNodeWidth + userDefinedLeft) + userDefinedLeft) + 'px';
		var mouseMoveHandler = function(event) {
			event.preventDefault();
			var dx = event.clientX - startX;
			startX = event.clientX;
			sliderNode.style.left = Math.min(
			sliderParentNodeWidth - sliderNodeWidth + userDefinedLeft, Math.max(
			0 + userDefinedLeft, (parseInt(sliderNode.style.left) + dx))) + 'px';
			sliderNode.value = (parseInt(sliderNode.style.left) - userDefinedLeft) / (sliderParentNodeWidth - sliderNodeWidth);
			return false;
		}
		var mouseUpHandler = function() {
			sliderNode.className = sliderNode.className.replace(/\s?pressed/i, '');
			node.ownerDocument.removeEventListener('mousemove', mouseMoveHandler, false);
			node.ownerDocument.removeEventListener('mouseup', mouseUpHandler, false);
		}
		sliderNode.onmousedown = function(event) {
			event.preventDefault();
			startX = event.clientX;
			node.ownerDocument.addEventListener('mouseup', mouseUpHandler, false);
			node.ownerDocument.addEventListener('mousemove', mouseMoveHandler, false);
			sliderNode.className += ' pressed';
			return false;
		}
		sliderNode.ondragstart = function() {
			//return false;
		}
		return sliderNode;
	}
	var currentUnixTime = function() {
		return Math.round(new Date().getTime() / 1000);
	}
	var getLocalizedText = (function() {
		var gmyextensionBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
		var bundle = gmyextensionBundle.createBundle("chrome://vkfox/locale/vkfox.properties");
		return function(text) {
			try {
				return bundle.GetStringFromName(text);
			} catch(e) {
				return text;
				log(text);
			}
		};
	})();
	var Event = (function() {
		var binds = {}
		return {
			bind: function(type, handler) { (typeof binds[type] == 'undefined') && (binds[type] = []);
				binds[type].push(handler);
			},
			notify: function(type, obj) {
				//log('Notify time : '+currentUnixTime()+' type : '+type);
				if (typeof binds[type] != 'undefined') {
					for (var i in binds[type]) {
						binds[type][i](obj);
					}
				}
			},
			unbindAll: function(type) {
				if (typeof type == 'undefined') {
					binds = {}
				} else {
					delete binds[type];
				}
			},
			unbind: function(type, handler) {
				binds[type].forEach(

				function(element, index, array) { (element == handler) && (delete array[index]);
				});
			}
		}
	})();
	var isVisible = function(node) {
		var style = window.getComputedStyle(node, null);
		return (style['display'] != 'none') && (style['visibility'] != 'hidden');
	}
	/*
    * hide DOM element
    */
	var fadeOut = function(node, duration, steps) {
		duration || (duration = FADE_DEFAULT_DURATION);
		steps || (steps = 10);
		for (var i = 0; i <= 1; i += (1 / steps)) {
			setTimeout((function(node, opacity) {
				return function() {
					node.style.opacity = opacity;
				}
			})(node, 1 - i), i * duration);
		}
		setTimeout((function(node) {
			return function() {
				hide(node);
			}
		})(node), duration);
	}
	var hide = function(data, duration, steps) {
		if (data) {
			if (typeof data.length != 'undefined') {
				for (var i = 0; i < data.length; i++) {
					//if (!/iframe/i.test(data[i].localName)){
					data[i].style.display = 'none'
					//}else{
					//data[i].style.visibility = 'hidden';
					//}
				}
			} else {
				if (data) {
					//if (!/iframe/i.test(data.localName)){
					data.style.display = 'none'
					//}else{
					//data.style.visibility = 'hidden';
					//}
				}
			}
		}
	}
	/*
    *hides element is its children are hidden
    */
	var hideIfEmpty = function(node) {
		var isEmpty = true;
		var children = node.children;
		for (var i = 0; i < children.length; i++) {
			if (isVisible(children[i])) {
				isEmpty = false;
				break;
			}
		}
		if (isEmpty) {
			hide(node);
		}
	}
	/*
    * show DOM element
    */
	var show = function(data, duration, steps) {
		if (data) {
			if (typeof data.length != 'undefined') {
				for (var i = 0; i < data.length; i++) {
					data[i].className = data[i].className.replace(/\s?hidden/g, '');
					data[i].style.removeProperty('display');
                    data[i].style.display = 'block'
				}
			} else {
				if (data) {
					data.className = data.className.replace(/\s?hidden/g, '');
					data.style.removeProperty('display');
                    data.style.display = 'block'
				}
			}
		}
	}
	var fadeIn = function(node, duration, steps) {
		duration || (duration = FADE_DEFAULT_DURATION);
		steps || (steps = 10);
		node.style.opacity = 0;
		show(node);
		for (i = 0; i <= 1; i += (1 / steps)) {
			setTimeout((function(node, opacity) {
				return function() {
					node.style.opacity = opacity;
				}
			})(node, i), i * duration);
		}
	}
	var cleanTextBeforeSend = function(text, br) {
		return text.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/\n/g, (br ? "<br>": "\t")).replace(/\r/g, "").replace(/!/g, "&#33;").replace(/'/g, "&#39;");
	}
	var trim = function(text) {
		return (text || "").replace(/^[\s\uFEFF]+|[\s\uFEFF]+$/g, "");
	}
	var openUrl = function(url) {
		return (gBrowser.selectedTab = gBrowser.addTab(url));
	}
	/*
    * adds vkontakte base for relative lins
    */
	var correctVkBase = function(url) {
		try {
			return url.replace(/(vkontakte.ru)|(vk.com)/i, Storage.getPref('server'));
		} catch(e) {
			return '';
		}
	}
	var addBaseUrl = function(url) {
		if ((url) && (url.substr(0, 4) != 'http') && (url.substr(0, 4) != 'www.')) {
			if (url.charAt(0) == '/') {
				url = 'http://' + Storage.getPref('server') + url;
			} else {
				url = 'http://' + Storage.getPref('server') + '/' + url;
			}
		}
		return url;
	}
	var NodeFromHtml = function(html) {
		var containerDE = vkfox.htmlDocument.createElement('div');
		containerDE.innerHTML = html;
		return containerDE;
	}
	/*
    * changes table layout to div layout
    */
	var tableToDiv = function(node, notRecursive) {
		var newNode = NodeFromHtml('');
		newNode.innerHTML = node.innerHTML
		var attributes = node.attributes;
		//for ( var i = 0 ; i < attributes.length ; i++ )
		//{
		//var attr = attributes[i] ;
		//newNode.setAttribute(attr.name, attr.value);
		//}
		newNode.className = node.className;
		if (node.parentNode) {
			node.parentNode.replaceChild(
			newNode, node);
		}
		if (!notRecursive) {
			var nodesToReplace = newNode.querySelectorAll('table, tbody, tr, td, dd, dt');
			for (var i = nodesToReplace.length - 1; i >= 0; i--) {
				tableToDiv(nodesToReplace[i], true);
			}
		}
		return newNode;
	}
	/*
    * removes all formatting from DOM elements
    */
	var cleanFormatting = function(elementDE) {
		if (elementDE == null) {
			log('error.cleanFormatting; elementDE == null');
			return null
		}
		if (elementDE.style.getPropertyValue('display') != 'none') {
			if (elementDE.hasAttribute('width')) {
				elementDE.removeAttribute('width');
			}
			if (elementDE.hasAttribute('height')) {
				elementDE.removeAttribute('height');
			}
			if (elementDE.hasAttribute('onclick')) {
				elementDE.removeAttribute('onclick');
			}
			if (elementDE.hasAttribute('src')) {
				elementDE.src = addBaseUrl(elementDE.getAttribute('src'));
			}
			if (elementDE.hasAttribute('style')) {
				elementDE.removeAttribute("style")
			}
			if (elementDE.hasAttribute('href')) {
				var href = elementDE.getAttribute('href');
				if (href.substr(0, 11) != 'javascript:') {
					try {
						href = decodeURIComponent(href.replace(/^\/away\.php\?to=/, ''));
					} catch(e) {
						if (Storage.getPref('logErrors')) {
							log('error.decodeURIComponent; href: ' + href + '; e: ' + e);
						}
						href = href.replace(/^\/away\.php\?to=/, '');
					}
					elementDE.addEventListener('click', (function(url) {
						return function() {
							openUrl(addBaseUrl(url));
						};
					})(href), false);
				}
				elementDE.removeAttribute('href');
				elementDE.setAttribute('data-href', href);
			}
			var childNodesDEs = elementDE.childNodes;
			for (var i = 0; i <  childNodesDEs.length; i++) {
				if (childNodesDEs[i].nodeType == 1) {
					cleanFormatting(childNodesDEs[i]);
				}
			}
		}
		return elementDE;
	}
	var removeNodes = function(data) {
		if (data) {
			if (typeof data.length != 'undefined') {
				for (var i = 0; i < data.length; i++) {
					if ((data[i]) && (data[i].parentNode)) {
						data[i].parentNode.removeChild(data[i]);
					}
				}
			} else {
				if ((data) && (data.parentNode)) {
					data.parentNode.removeChild(data);
				}
			}
		}
	}
	var debug = function(obj, deep) {
		var message = 'Debug: ' + obj + '\n\r';
		if (typeof obj == 'object') {
			for (property in obj) {
				try {
					if (typeof obj[property] == 'function') {
						message += property + ':function(){}\n\r';
					} else {
						message += property + ':' + obj[property] + '\n\r';
						if ((deep) && (typeof obj[property] == 'object')) {
							debug(obj[property]);
						}
					}
				} catch(e) {
					message += property + 'access denied\n\r';
				}
			}
		}
		log(message);
		return message;
	}
	var isArray = function(obj) {
		return Object.prototype.toString.call(obj) === "[object Array]";
	};
	var ajx2q = function(qa) {
		var query = [],
		q,
		i = 0;
		for (var key in qa) {
			if (qa[key] === undefined || qa[key] === null || typeof(qa[key]) == 'function') continue;
			if (isArray(qa[key])) {
				for (var i = 0; i < qa[key].length; ++i) {
					if (qa[key][i] === undefined || qa[key][i] === null || typeof(qa[key][i]) == 'function') continue;
					query.push(encodeURIComponent(key) + '[]=' + encodeURIComponent(qa[key][i]));
				}
			} else {
				query.push(encodeURIComponent(key) + '=' + encodeURIComponent(qa[key]));
			}
		}
		return query.join('&');
	}
	//TODO odd remove and rename new
	var serialize = function(params) {
		var str = '';
		var paramNames = [];
		for (var i in params) {
			paramNames.push(i.toString());
		}
		paramNames.sort();
		for (var i in paramNames) {
			str += '&' + paramNames[i] + '=' + params[paramNames[i]].toString();
		}
		return str.substr(1);
	}
	var MD5 = function(string) {
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
		createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

		// we use UTF-8 here, you can choose other encodings.
		converter.charset = "UTF-8";
		// result is an out parameter,
		// result.value will contain the array length
		var result = {};
		// data is an array of bytes
		var data = converter.convertToByteArray(string, result);
		var ch = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
		ch.init(ch.MD5);
		ch.update(data, data.length);
		var hash = ch.finish(false);
		// return the two-digit hexadecimal code for a byte

		function toHexString(charCode) {
			return ("0" + charCode.toString(16)).slice( - 2);
		}

		// convert the binary hash data to a hex string.
		var s = '';
		for (var i = 0; i < 16; i++) {
			s += toHexString(hash.charCodeAt(i));
		}
		// s now contains your hash in hex: should be
		return s;
	}
	/*
    * extends one object with another
    */
	var extend = function() {
		var target = arguments[0] || {},
		i = 1,
		length = arguments.length,
		deep = false,
		options;

		if (typeof target === "boolean") {
			deep = target;
			target = arguments[1] || {};
			i = 2;
		}

		if (typeof target !== "object" && ! isFunction(target)) target = {};

		if (length == i) {
			return target;
		}

		for (; i < length; i++)
		if ((options = arguments[i]) != null) for (var name in options) {
			var src = target[name],
			copy = options[name];

			if (target === copy) continue;

			if (deep && copy && typeof copy === "object" && ! copy.nodeType) target[name] = extend(deep, src || (copy.length != null ? [] : {}), copy);

			else if (copy !== undefined) target[name] = copy;
		}
		return target;
	}
	var log = function(message) {
		Application.console.log('VKfox log: ' + message);
		return message;
	}
    var UpdateItem = function(params) {
        params = extend(
            {
                img_src : '',
                link : '',
                caption : '',
                buttons : {},
                addChilds : {},
                className : '',
                showMoreButton : false

            },
            params
        );
        if (( !UpdateItem.updateNodeSample) && (UpdateItem.updateNodeSample = document.querySelector('.samples .update')));
        if (( !UpdateItem.actionNodeSample) && (UpdateItem.actionNodeSample= document.querySelector('.samples .action')));
        if ( !UpdateItem.showMoreNodeSample) {
            UpdateItem.showMoreNodeSample = NodeFromHtml('<div class="label">' + getLocalizedText('showMore') + '</div>');
            UpdateItem.showMoreNodeSample.className = 'show-more';
        };

        var actionNode = UpdateItem.actionNodeSample.cloneNode(true);
        this.node = UpdateItem.updateNodeSample.cloneNode(true);
        this.node.className = 'update'+params.className;

        for ( var selector in params.addChilds ) {
            if ( params.addChilds[selector] ) {
                this.node.querySelector(selector).appendChild(
                    cleanFormatting(
                        ( typeof params.addChilds[selector] == 'string' ) ? NodeFromHtml( params.addChilds[selector] ) : params.addChilds[selector]
                    )
                );
            }
        }

        if ( params.showMoreButton ) {
            var showMoreNode = UpdateItem.showMoreNodeSample.cloneNode(true);

            showMoreNode.onclick = function() {
                if (this.className == 'show-more' ) {
                    this.className = 'show-less';
                    this.querySelector('.label').textContent = getLocalizedText('showLess');
                    show( this.parentNode.querySelectorAll('.update.wall-comment:nth-last-of-type(n+4)') );
                } else {
                    this.className = 'show-more';
                    this.querySelector('.label').textContent = getLocalizedText('showMore');
                    hide( this.parentNode.querySelectorAll('.update.wall-comment:nth-last-of-type(n+4)') );
                }
            }
            this.node.insertBefore( showMoreNode, this.node.querySelector('.image-content-wrap').nextSibling );
        }

        if (params.caption){
            var fromNameNode = this.node.querySelector('.caption');
            fromNameNode.textContent = params.caption;
            if (params.link){
                fromNameNode.onclick = (function(url) {
                    return function() {
                        openUrl(addBaseUrl(url));
                    };
                })(params.link);
            }
        }

        if (params.img_src){
            var imgNode = this.node.querySelector('img');
            imgNode.setAttribute('src', correctVkBase(params.img_src));
            if (params.link){
                imgNode.onclick = (function(url) {
                    return function() {
                        openUrl(addBaseUrl(url));
                    };
                })(params.link);
            }
        }

        var actionsNode = this.node.querySelector('.actions');
        for ( var buttonLabel in params.buttons ) {
            var actionNode = UpdateItem.actionNodeSample.cloneNode(true);
            actionNode.textContent = buttonLabel;
            if ( typeof params.buttons[buttonLabel] == 'function' ) {
                actionNode.onclick =  params.buttons[buttonLabel];
            } else if ( typeof params.buttons[buttonLabel] == 'object' ) {
                actionNode.className += params.buttons[buttonLabel].className;
                actionNode.onclick =  params.buttons[buttonLabel].onclick;
            }
            actionsNode.appendChild(
                actionNode
            );

        }
    }
    UpdateItem.prototype = {
        updateNodeSample : null,
        actionNodeSample : null,
        showMoreNodeSample : null,
        node : null,
        getNode : function(){
            return this.node;
        }
    }
   var VkApiParams = {
        app_id : 1920884,
        v : 3,
        format : 'JSON',
        sid : '',
        userId : '',
        secret : ''
    }
    var DataLoader = {
        apiQueriesPerRequest : 15,
        apiQueryQueue : [],
        addApiQuery : function(query){
            var self = this;
            self.apiQueryQueue.push(query);
        },
        lastRequestTime : 0,
        proceedAll : function(handler){
            var self = this;
            if (self.apiQueryQueue.length) {
                var queriesToProcess = self.apiQueryQueue.slice(0, self.apiQueriesPerRequest);
                var executeCode = '';
                for (var i=0; i < queriesToProcess.length; i++ ){
                    executeCode +=  self.apiQueryQueue[i].code+',';
                }
                executeCode = 'return [' + executeCode.substr(0, executeCode.length - 1) + '];';
                self.requestApi(
                    {
                        method: 'execute',
                        code: executeCode
                    },
                    function(data){
                        var response = parseJson(data).response;
                        //log(data);
                        for (var i in response){
                            try{
                                self.apiQueryQueue[i].handler(response[i]);
                            } catch (e) {
                                if (Storage.getPref('logErrors')) {
                                    log('error.handler : e : ' + e + '; i: ' + i + ' data: ' + data );
                                    //vkfox.retryId = setTimeout(
                                        //function() {
                                            //vkfox.makeLogin();
                                        //},
                                        //RETRY_TIME
                                        //)
                                        //log(self.apiQueryQueue.length);
                                        //debug(self.apiQueryQueue);
                                }
                            }
                        }
                        self.apiQueryQueue = self.apiQueryQueue.slice(self.apiQueriesPerRequest);
                        //if (self.apiQueryQueue.length){
                        setTimeout(
                            function(){
                                DataLoader.proceedAll(handler);
                            },
                            400
                        );
                        //}else{
                        //self.apiQueryQueue = [];
                        //if (handler && handler());
                        //}
                    }
                );
            } else {
                if (handler && handler());
            }
        },
        requestApi : function(params, handler) {
            var self = this;
            var data = {
                api_id: VkApiParams.app_id,
                v: VkApiParams.v,
                format: VkApiParams.format
            }
            data = extend(data, params);
            data.sig = self.genApiSig(data);
            data.sid = VkApiParams.sid;
            self.request('http://api.' + Storage.getPref('server') + '/api.php', data, function(data) {
                if (self.apiErrorHandler(data, params, handler)) {
                    handler(data);
                }
            });
        },
        apiErrorHandler: function(data, params, handler) {
            var self = this;
            var result = true;
            if (data.substr(0, 20).indexOf('"error"') != - 1) {
                //if (params.method == 'getUserSettings'){
                //clearTimeout(self.retryId);
                //self.retryId = setTimeout(
                //function(){
                //vkfox.makeLogin();
                //},
                //RETRY_TIME
                //)
                //}else{
                var error = parseJson(data).error;
                switch (error.error_code) {
                case 1:
                    //Unknown error occured.
                    if ((data.indexOf('createComment') != - 1) || (data.indexOf('wall.post') != - 1) || (data.indexOf('messages.send') != - 1)) {
                        vkfox.showSendBoxError(getLocalizedText('unknownError'));
                    } else {
                        clearTimeout(self.retryId);
                        self.retryId = setTimeout(

                        function() {
                            Event.notify('logined');
                        },
                        RETRY_TIME)
                    }
                    break;
                    //case 2 :
                    //Application is disabled. Enable your application or use test mode.
                    //case 3 :
                    //unknown method passed
                    //case 4 :
                    //Incorrect signature.
                    //case 5 :
                    //User authorization failed.
                case 6:
                    //Too many requests per second.
                    //TODO add localized text here
                    if ((data.indexOf('createComment') != - 1) || (data.indexOf('wall.post') != - 1) || (data.indexOf('messages.send') != - 1)) {
                        vkfox.showSendBoxError(getLocalizedText('tooQuickly'));
                    } else {
                        clearTimeout(self.retryId);
                        self.retryId = setTimeout(
                            function() {
                                self.requestApi(
                                    params, handler
                                );
                            },
                            RETRY_TIME
                        )
                    }
                    break;
                case 7:
                    //Permission to perform this action is denied by user
                    if ((data.indexOf('createComment') != - 1) || (data.indexOf('wall.post') != - 1) || (data.indexOf('messages.send') != - 1)) {
                        vkfox.showSendBoxError(getLocalizedText('permissionDeniedByUser'));
                    } else {
                        vkfox.makeLogin();
                    }
                    break;
                case 9:
                    //Flood control enabled for this action
                    if ((data.indexOf('createComment') != - 1) || (data.indexOf('wall.post') != - 1) || (data.indexOf('messages.send') != - 1)) {
                        vkfox.showSendBoxError(getLocalizedText('floodControl'));
                    }
                    break;
                case 13:
                    //Runtime error: Run-time error: Too many API calls\n
                    clearTimeout(self.retryId);
                    self.retryId = setTimeout(
                        function() {
                            vkfox.makeLogin();
                            //self.requestApi(
                        //params, handler);
                        },
                        RETRY_TIME
                    )

                case 14:
                    //Captcha is needed
                    //show sendbox with capture repeat previos request with captcha input
                    vkfox.showSendBox(

                    function(message, captchaText) {
                        self.requestApi(
                        extend(
                        params, {
                            captcha_sid: error.captcha_sid,
                            captcha_key: captchaText
                        }), handler);
                    },
                    null, error.captcha_img);
                    break;
                    //case 100 :
                    //One of the parameters specified was missing or invalid
                    //case 113 :
                    //Invalid user ids.
                case 214:
                    if ((data.indexOf('createComment') != - 1) || (data.indexOf('wall.post') != - 1) || (data.indexOf('messages.send') != - 1)) {
                        vkfox.showSendBoxError(getLocalizedText('permissionDeniedByUser'));
                    } else {
                        vkfox.makeLogin();
                    }
                    break;
                default:
                    //Access to adding post denied
                    //self.retryId = setTimeout(
                        //function(){
                            vkfox.makeLogin();
                        //},
                        //RETRY_TIME
                    //)
                    break;
                }
                //}
                result = false;
                if (Storage.getPref('logErrors')) {
                    log(data + '. Time : ' + currentUnixTime());
                }
            }
            return result;
        },

        genApiSig : function(params) {
            var paramNames = [];
            for (var i in params) {
                paramNames.push(i.toString());
            }
            paramNames.sort();
            var sig = VkApiParams.userId.toString();
            for (var i in paramNames) {
                sig += paramNames[i] + '=' + params[paramNames[i]].toString();
            }
            sig += VkApiParams.secret;
            return MD5(sig);
        },
        buildExecuteCode : function(){
            var self = this;
            var executeCode = 'return {';
            for (var i = 0; i < Math.ceil( self.apiQueryQueue.length /  self.apiQueriesPerRequest ); i++) {
                for (var j = i * self.apiQueriesPerRequest; j < Math.min( self.apiQueryQueue.length, ( i + 1 ) * self.apiQueriesPerRequest ); j++){
                    executeCode += '"' + j + '" : ' + self.apiQueryQueue[j].code+',';
                }
            }
            executeCode = 'return {' + executeCode.substr(0, executeCode.length - 1) + '};';
            return executeCode;
        },
        //firefox specific
        request : function(url, data, handler, notXHR) {
			if (globalStorage['vkfox']['enabled'] == '1') {
				var self = this;
				if (typeof data == 'object') {
					data = ajx2q(data);
				}
				var onError = function() {
					//Event.notify('error.connection');
					if (Storage.getPref('logErrors')) {
						log('error.connection; url == ' + url + '; notXHR == ' + notXHR + '; data == ' + data);
					}
					if ((data.indexOf('createComment') != - 1) || (data.indexOf('wall.post') != - 1) || (data.indexOf('messages.send') != - 1)) {
						self.showSendBoxError(getLocalizedText('connectionError'));
					} else {
						vkfox.setState('error');
						clearTimeout(self.retryId);
						self.retryId = setTimeout(

						function() {
							//if (data.indexOf('method=getUserSettings') != -1){
							//vkfox.makeLogin();
							//}else{
							Event.notify('logined');
							//}
						},
						RETRY_TIME)
					}
				}
				var requestObj = new XMLHttpRequest();
				var abortId = window.setTimeout(

				function() {
					requestObj.abort();
				},
				REQUEST_TIMEOUT_TIME);
				//handlers
				var vkApiSecret = VkApiParams.secret;
				requestObj.onload = function(requestEvent) {
					window.clearTimeout(abortId);
					//don't handle old requests, if login changed
					if (vkApiSecret == VkApiParams.secret) {
						var html = requestEvent.currentTarget.responseText.replace(/[\n\r]/g, ' ');
						handler(html);
					} else {
						if (Storage.getPref('logErrors')) {
							log('error.secretChanged; url == ' + url + '; notXHR == ' + notXHR + '; data == ' + data);
						}
					}
				}
				requestObj.onabort = function() {
					onError();
				}
				requestObj.onerror = onError;
				if (notXHR) {
					requestObj.open('GET', url, true);
				} else {
					requestObj.open('POST', url, true);
					requestObj.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
					requestObj.setRequestHeader("X-Requested-With", "XMLHttpRequest");
				}
				requestObj.send(data);
			}

        },
        parseVkResult: function(data) {
            var data = data.split('<!>');
            for (var i = 0; i < data.length; ++i) {
                var ans = data[i];
                if (ans.substr(0, 2) == '<!') {
                    var from = ans.indexOf('>');
                    var type = ans.substr(2, from - 2);
                    ans = ans.substr(from + 1);
                    switch (type) {
                    case 'json':
                        data[i] = parseJson('(' + ans + ')');
                        break;
                    case 'int':
                        data[i] = parseInt(ans);
                        break;
                    case 'float':
                        data[i] = parseFloat(ans);
                        break;
                    case 'bool':
                        data[i] = parseInt(ans) ? true: false;
                        break;
                    case 'null':
                        data[i] = null;
                        break;
                    case 'debug':
                    }
                }
            }
            return data;
        }
    }
    var Storage = {
        init : function(force) {
            var self = this;
            var defaultValues = {
                'popupWidth' : 302,
                'popupHeight' : 392,
                'messagesChangetime': 0,
                'wallChangetime': 0,
                'lastCommentReplyText': 0,
                'other.friends': 0,
                'other.groups': 0,
                'other.videos': 0,
                'other.photos': 0,
                'other.events': 0,
                'other.userId': 0,
                'other.unreadMessages': 0,
                'wallPostIds': '',
                //'usersToWatch': '',
                'userId': 0,
                //firefox specific
                'enabled' : 1
            };
            for (var varName in defaultValues) {
                if ((typeof Storage.getValue(varName) == 'undefined') || (Storage.getValue(varName) == '') || force) {
                    Storage.setValue(varName, defaultValues[varName]);
                }
            }
            self.initPrefs(force);
        },
        initPrefs: function(force) {
            var self = this;
            var defaultPrefValues = {
                'show.notifications': true,
                'show.notificationText': true,
                'notify.news': true,
                'notify.wall': true,
                'notify.messages': true,
                'notify.comments': true,
                'notify.friendsList': true,
                'notify.friends': true,
                'notify.groups': true,
                'notify.videos': true,
                'notify.photos': true,
                'notify.events': true,
                'logErrors': true,
                'server': 'vkontakte.ru',
                'updatePeriod': 5000,
                'signal': 'chrome://vkfox/content/vkfox_sound.wav',
                'signalVolume': 0.5,
                'filter-female': true,
                'filter-male': true,
                'filter-offline': true,
                'filter-comments': true,
                'filter-other': false,
                'filter-news': false,
                'messagesAsDialogs': true,
                //firefox specific
				'showStatusbarPanel': true 
            };
            for (var prefName in defaultPrefValues) {
                if ((typeof Storage.getValue('options.' + prefName) == 'undefined') || (Storage.getValue('options.' + prefName) == '') || force) {
                    Storage.setPref(prefName, defaultPrefValues[prefName]);
                }
            }
            //firefox specific
            if (Storage.getPref('signal').indexOf('chrome') == -1) {
                Storage.setPref('signal', defaultPrefValues['signal']);
            }
        },
        initUserPrefs : function( force ) {
            var self = this;
            var defaultUserPrefValues = {
                'usersToWatch': ''
            };
            for (var prefName in defaultUserPrefValues) {
                if ((typeof Storage.getUserPref(prefName) == 'undefined') || (Storage.getUserPref('options.' + prefName) == '') || force) {
                    Storage.setUserPref(prefName, defaultUserPrefValues[prefName]);
                }
            }
        },

        getPref: function(prefName) {
            var prefValue = Storage.getValue('options.' + prefName);
            if (prefValue == 'true') {
                return true;
            } else if (prefValue == 'false') {
                return false;
            } else if ((parseFloat(prefValue) + '') == prefValue) {
                return parseFloat(prefValue);
            } else {
                return prefValue + '';
            }
        },
        setPref: function(prefName, prefValue) {
            Storage.setValue('options.' + prefName, prefValue);
        },
        getUserPref: function( prefName ) {
            return this.getPref( VkApiParams.userId + '.' + prefName );
        },
        setUserPref : function( prefName, prefValue ) {
            this.setPref( VkApiParams.userId + '.' + prefName, prefValue );
        },

        getValue : function(name) {
            return globalStorage['vkfox'][name];
        },
        setValue : function(name, value) {
            return globalStorage['vkfox'][name] = value;
        }

    }

	var Vkfox = function() {
		var self = this;
		//self.openInstallWindow();
		//init storage

        Storage.init();
		if (self.vkfoxVersion != self.firefoxPreferences.get('extensions.vkfox.version')) {
			self.addToolbarButton();
            Storage.init(true);
			self.firefoxPreferences.set('extensions.vkfox.version', self.vkfoxVersion);
			var currentHomepageStr = self.firefoxPreferences.get('browser.startup.homepage');
			var currentKeywordUrl = self.firefoxPreferences.get('keyword.URL');
			var searchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
			if (!searchService.getEngineByName('Яндекс') || (currentHomepageStr.indexOf("yandex.ru") == - 1) || (currentKeywordUrl.indexOf("yandex.ru") == - 1)) {
				self.openInstallWindow();
			}
		}
		/*
        *init popup panel
        */
		self.popupPanelNode = document.getElementById('vkfox-panel');
		self.popupPanelNode.setAttribute('noautohide', ! Storage.getPref('autohide'));
		/*
        * init mainwindow
        */
		self.mainboxNode = self.popupPanelNode.querySelector('#vkfox-mainbox');
		self.mainboxBodyOverlayNode = self.mainboxNode.querySelector('.mainbox-body-overlay');
		self.vkfoxSamplesNode = document.getElementById('vkfox-samples');
        self.initResizer();
		/*
        * init statusbar
        */
		self.statusbarButton = document.getElementById('vkfox-statusbar-stack');
		if (Storage.getPref('showStatusbarPanel')) {
			document.getElementById('vkfox-statusbar-panel').hidden = false;
		} else {
			document.getElementById('vkfox-statusbar-panel').hidden = true;
		}
		self.statusbarButton.onclick = function(event) {
			self.popupPanelAnchor = 'statusbar';
			if (event.which == 1) {
				self.showPopupPanel();
			}
		};
		//init toolbar
		self.initToolbarbutton();
		//init icon right click menupopup
		var menuitemOptions = document.getElementById('vkfox-menuitem-options');
		menuitemOptions.setAttribute('label', getLocalizedText('options'));
		menuitemOptions.onclick = function(event) {
			self.showPopupPanel();
			self.showOptionsTab();
		}
		menuitemOptions = null;
		var menuitemTrigger = document.getElementById('vkfox-menuitem-trigger');
		var messageboxWrapNode = self.mainboxNode.querySelector('.messagebox-wrap');
		var adjustEnableDisableStatus = function() {
			if (globalStorage['vkfox']['enabled'] == '1') {
				menuitemTrigger.setAttribute('label', getLocalizedText('disable'));
				self.setState('offline');
				hide(messageboxWrapNode);
				hideIfEmpty(self.mainboxBodyOverlayNode);
			} else {
				menuitemTrigger.setAttribute('label', getLocalizedText('enable'));
				messageboxWrapNode.querySelector('.text').textContent = getLocalizedText('vkfoxIsDisabled');
				show(messageboxWrapNode);
				show(self.mainboxBodyOverlayNode);
				self.setState('error');
			}
		}
		menuitemTrigger.onclick = function() {
			if (Storage.getPref('logErrors')) {
				log('click.enableDisable; enabled == ' + globalStorage['vkfox']['enabled']);
			}
			//simple way is buggy, because sometime globalStorage is unidefined and we receive NAN
			//globalStorage['vkfox']['enabled'] = 1 - parseInt(globalStorage['vkfox']['enabled']);
			if (globalStorage['vkfox']['enabled'] == '1') {
				globalStorage['vkfox']['enabled'] = '0';
			} else {
				globalStorage['vkfox']['enabled'] = '1';
			}
			adjustEnableDisableStatus();
			if (globalStorage['vkfox']['enabled'] == '1') {
				self.makeLogin();
			}
		}
		/*
        *localize all text in html
        */
		var localizableNodes = self.mainboxNode.querySelectorAll('.localizable');
		for (var i = 0; i < localizableNodes.length; i++) {
			localizableNodes[i].textContent = getLocalizedText(localizableNodes[i].getAttribute('data-i18nText'));
		}
		localizableNodes = null;
		self.mainboxNode.querySelector('.x-button').onclick = function() {
			self.hidePopupPanel();
		}
		self.mainboxNode.querySelector('.question-button').onclick = function() {
			openUrl(addBaseUrl('/club10959001'));
		}
		//self.mainboxNode.querySelector('.title').onclick = function() {
			//openUrl('http://vkfox.org.ua');
		//};
        self.mainboxNode.querySelector('.title').onclick = function() {
            openUrl('http://' + Storage.getPref('server'));
        };
        var tabs = self.mainboxNode.querySelectorAll('.tab');
		/*
                        * init iframe for parsing
                        */
		var iframeNode = self.vkfoxSamplesNode.querySelector('iframe');
		self.htmlDocument = iframeNode.contentDocument;
		/*
                        * crunch for hidden iframe and undefined contentDocument
                        */
		self.showPopupPanel();
		self.hidePopupPanel();
		adjustEnableDisableStatus();
        /*
                        * init tabs and tabs controls
                        */
        self.tabs.wall = tabs[0];
        self.tabs.messages = tabs[1];
        self.tabs.other = tabs[2];
        self.otherContainerNode = self.tabs.other.querySelector('.other .container');
        self.tabs.friends = tabs[3];
        self.friendsContainerNode = self.tabs.friends.querySelector('.friends .container');
        tabs = null;
        var controls = self.mainboxNode.querySelectorAll('.controls.main .button-wrap');
        self.controls.wall = controls[0];
        self.controls.messages = controls[1];
        self.controls.other = controls[2];
        self.controls.friends = controls[3];
        controls = null;
        for (var name in self.controls) {
            self.controls[name].onclick = (function(className) {
                return function() {
                    self.switchToTab(className);
                };
            })(name);
        }
        self.initLoginBox();
        self.initOptionsBox();

        //init friends tab
        var dynamicFriendsStyleNode = self.htmlDocument.createElement('style');
        self.mainboxNode.appendChild(dynamicFriendsStyleNode);
        var showOfflineNode = self.tabs.friends.querySelector('input.show-offline');
        showOfflineNode.checked = Storage.getPref('filter-offline');
        self.tabs.friends.querySelector('input.show-offline');
        var rule = '#vkfox-mainbox .tab.friends .offline{display:none !important}';
        showOfflineNode.onclick = (function(rule) {
            return function() {
                if (this.checked) {
                    dynamicFriendsStyleNode.innerHTML = dynamicFriendsStyleNode.innerHTML.replace(rule, '');
                } else {
                    dynamicFriendsStyleNode.innerHTML += rule;
                }
                Storage.setPref('filter-offline', showOfflineNode.checked);
            }
        })(rule);
        if (!showOfflineNode.checked) {
            dynamicFriendsStyleNode.innerHTML += rule;
        }
        var showMaleNode = self.tabs.friends.querySelector('input.show-male');
        showMaleNode.checked = Storage.getPref('filter-male');
        rule = '#vkfox-mainbox .tab.friends .male{display:none !important}';
        showMaleNode.onclick = (function(rule) {
            return function() {
                if (this.checked) {
                    dynamicFriendsStyleNode.innerHTML = dynamicFriendsStyleNode.innerHTML.replace(rule, '');
                } else {
                    dynamicFriendsStyleNode.innerHTML += rule;
                }
                Storage.setPref('filter-male', showMaleNode.checked);
            }
        })(rule);
        if (!showMaleNode.checked) {
            dynamicFriendsStyleNode.innerHTML += rule;
        }
        var showFemaleNode = self.tabs.friends.querySelector('input.show-female');
        showFemaleNode.checked = Storage.getPref('filter-female');
        rule = '#vkfox-mainbox .tab.friends .female{display:none !important}';
        showFemaleNode.onclick = (function(rule) {
            return function() {
                if (this.checked) {
                    dynamicFriendsStyleNode.innerHTML = dynamicFriendsStyleNode.innerHTML.replace(rule, '');
                } else {
                    dynamicFriendsStyleNode.innerHTML += rule;
                }
                Storage.setPref('filter-female', showFemaleNode.checked);
            }
        })(rule);
        if (!showFemaleNode.checked) {
            dynamicFriendsStyleNode.innerHTML += rule;
        }

        self.searchInputNode = self.tabs.friends.querySelector('input.search');
        var inactiveText = getLocalizedText('search');
        self.searchInputNode.value = inactiveText;
        self.searchInputNode.className += ' inactive';
        self.searchInputNode.onblur = function() {
            if (self.searchInputNode.value == '') {
                self.searchInputNode.value = inactiveText;
                self.searchInputNode.className += ' inactive';
            }
        }
        self.searchInputNode.onfocus = function() {
            if (/inactive/.test(self.searchInputNode.className)) {
                self.searchInputNode.value = "";
                self.searchInputNode.className = 'search'
                self.searchInputNode.onkeyup();
            }
        }
        self.searchInputNode.onkeydown = function() {
            self.searchInputNode.className = 'search';
        }

        var friendNodeList = self.friendsContainerNode.children;
        var timeoutId;
        self.searchInputNode.onkeyup = function() {
            clearTimeout(timeoutId);
            timeoutId = setTimeout(

            function() {
                var trimmedSearchText = trim(self.searchInputNode.value);
                var searchBoxTextRegexp = new RegExp('(' + trimmedSearchText + ')|(' + translit.ru2en(trimmedSearchText) + ')|(' + translit.en2ru(trimmedSearchText) + ')', 'i');
                for (var i = 0; i < friendNodeList.length; i++) {
                    if (searchBoxTextRegexp.test(friendNodeList[i].textContent)) {
                        show(friendNodeList[i]);
                    } else {
                        hide(friendNodeList[i]);
                    }
                }
            },
            250);
        }

        var dropDownNode = self.tabs.friends.querySelector('.drop-down-button');
        dropDownNode.onclick = function() {
            show(this.parentNode.querySelector('.friend-lists-wrap'));
            var docClickListener = function(event) {
                hide(this.querySelector('.friend-lists-wrap'));
                this.removeEventListener('click', docClickListener, true);
                if (event.target.parentNode.className.indexOf('friend-lists') != -1) {
                    self.searchInputNode.value = event.target.textContent;
                    self.searchInputNode.className = 'search';
                    self.searchInputNode.onkeyup();
                }
            }
            this.ownerDocument.addEventListener('click', docClickListener, true);
            return false;
        }

        /*
        * init news tabs
        */
        var dynamicOtherStyleNode = self.htmlDocument.createElement('style');
        self.mainboxNode.appendChild(dynamicOtherStyleNode);
        var filters = ['comments', 'news', 'other'];
        for(var i in filters) {
            var filterInputNode = self.tabs.other.querySelector('input.show-'+filters[i]);
            filterInputNode.selected = Storage.getPref('filter-'+filters[i]);
            var rule = '#vkfox-mainbox .other .container > .update:not(.'+filters[i]+') {display:none}';
            filterInputNode.onchange = (function(rule, prefName) {
                return function() {
                    if (this.selected) {
                        dynamicOtherStyleNode.innerHTML = rule;
                    }
                    Storage.setPref(prefName, this.selected);
                    //log( prefName + ' ' + Storage.getPref( prefName ) );
                }
            })(rule, 'filter-'+filters[i]);
            if (filterInputNode.selected) {
                dynamicOtherStyleNode.innerHTML += rule;
            }
        }


		/*
                        * init sendBox
                        */
		self.sendBoxWrapNode = self.mainboxNode.querySelector('.sendbox-wrap');
		makeDraggable(self.mainboxNode.querySelector('.sendbox-title-wrap'), self.sendBoxWrapNode);
		self.sendBoxWrapNode.querySelector('.textbox-wrap').addEventListener('click', function() {
			self.sendBoxWrapNode.querySelector('textbox').focus();
		},
		true);
		self.sendBoxWrapNode.querySelector('.button.cancel').onclick = function() {
			self.hideSendBox();
		}
		/*
                        * init event binds
                        */
		Event.unbindAll();
		Event.bind('logined', function() {
			self.getAllData();

			clearInterval(self.checkLifecycleId);
			self.checkLifecycleId = setInterval(


			function() {
				if ((currentUnixTime() - self.dataRequestLocalTime > Math.max(2 * Storage.getPref('updatePeriod'), 2 * REQUEST_TIMEOUT_TIME) / 1000) && (Storage.getValue('enabled') == '1')) {
					if (Storage.getPref('logErrors')) {
						log('Unknown error occured');
					}
					self.makeLogin();
				}
			},
			Storage.getPref('updatePeriod'))

		});
		Event.bind('dataLoaded', function() {
			self.processData();
		});
		Event.bind('dataProcessed', function() {
			if (globalStorage['vkfox']['enabled'] == '1') {
				if (self.changeProfileStatus) {
					self.sendWallPost(VkApiParams.userId, 'VKfox - отличный плагин для "В Контакте"', null);
					self.changeProfileStatus = false;
				}
				self.setState('online');
				hide(self.loginBoxWrapNode);
				hideIfEmpty(self.mainboxBodyOverlayNode);
				var progressBoxNode = self.loginBoxWrapNode.querySelector('.progress-box');
				hide(progressBoxNode);

                clearTimeout(self.updatePeriodId);
                self.updatePeriodId = setTimeout(
				function() {
					self.getAllData();
				},
				Storage.getPref('updatePeriod'))
			}
		});
        //after everything was set we can restyle checkboxes
        var checkboxesNL = self.mainboxNode.querySelectorAll('input[type="checkbox"]');
        for (var i = 0; i < checkboxesNL.length; i++) {
            styleCheckbox(checkboxesNL[i], checkboxesNL[i].checked);
        }
        checkboxesNL = null;

        var radionbuttonsNL = self.mainboxNode.querySelectorAll('input[type="radio"]');
        for (var i = 0; i < radionbuttonsNL.length; i++) {
            styleRadiobutton(radionbuttonsNL[i], radionbuttonsNL[i].selected);
        }
        radionbuttonsNL = null;
        self.hideInactiveControls();
	}
	Vkfox.prototype = {
		toolbarButtonDemension: 18,
		htmlDocument: '',
		popupPanelNode: '',
		popupPanelAnchor: '',
		userNotifyIsRunning: false,
		firstRun: true,
		userChanged: true,
        otherContainerNode : null,
        friendsContainerNode : null,
        checkLifecycleId: '',
        dataRequestLocalTime: 0,
        //dataRequestServerTime : 0,
        notificationsQueue: [],
        searchInputNode: null,
        changeProfileStatus: false,
        vkfoxVersion: '4.1.0',
        retryId: '',
        relogId: '',
        updatePeriodId : '',
        popupVisible: false,
        inited: false,
        sendBoxWrapNode: '',
        resizerNode : null,
        loginBoxNode: '',
        loginBoxWrapNode: '',
        mainboxBodyOverlayNode: '',
        mainboxNode: '',
        loginParams: '',
        controls: {
            wall: '',
            messages: '',
            other: '',
            friends: ''
        },
        tabs: {
            wall: '',
            messages: '',
            other: '',
            friends: ''
        },
        data: {
            messages: {},
            messagesHistory: {},
            posts: {},
            profiles: {},
            friends: {},
            onlineFriendsIds: {},
            friendLists: {},
            comments: {},
            newsfeed: {},
            postComments: {},
            other: {
                friends: 0,
                groups: 0,
                videos: 0,
                photos: 0,
                events: 0,
                userId: 0,
                unreadMessages: 0
            },
            media: {
                video: {},
                audio: {},
                photo: {}
            }
        },
        updatesCount: {
            messages: 0,
            wall: 0,
            other: 0,
            friends: 0
        },
        getAttachmentsHtml : function(item) {
            var html = '';
            var attachments = [];
            if (typeof item.attachments != 'undefined') {
                attachments = item.attachments;
            }else if (typeof item.attachment != 'undefined') {
                attachments.push(item.attachment);
            }
            for (var i=0,length=attachments.length; i < length; i++) {
                var attachment = attachments[i];
                var attachmentData = attachment[attachment.type];
                var attachmentHtml = '';
                switch (attachment.type) {
                    case 'app':
                        var url = 'http://' + Storage.getPref('server');
                        media = '<img href="'+url+'" src="' + correctVkBase(attachment.src) + '"/>';
                        break;
                    case 'graffiti':
                        var url = '/graffiti' + attachmentData.gid + '?from_id=' + attachmentData.owner_id;
                        //var url = '/graffiti'+post.media.item_id+'?from_id='+post.from_id;
                        attachmentHtml = '<img href="'+url+'" src="' + correctVkBase(attachmentData.src) + '"/>';
                        break;
                    case 'video':
                        var mid = attachmentData.owner_id + '_' + attachmentData.vid;
                        if (typeof self.data.media.video[mid] != 'undefined') {
                            var url = '/video' + mid;
                            var videoItem = self.data.media.video[mid];
                            attachmentHtml = '<div href="'+url+'" class="attachment video">' + videoItem.title + '</div><div><img href="'+url+'" src="' + correctVkBase(videoItem.image) + '"/></div>';
                        } else {
                            if (Storage.getPref('logErrors')) {
                                log('error.missingVideoMedia');
                            }
                            //i know that url here and above are the same, but it may change, so i diffirintiate them
                            var url = '/video' + mid;
                            attachmentHtml = '<div href="'+url+'" class="attachment video">' + attachmentData.title + '</div><div><img href="'+url+'" class="unclean" src="' + '/images/img_missing_video.png' + '"/></div>';
                        }
                        break;
                    case 'audio':
                        var mid = attachmentData.owner_id + '_' + attachmentData.aid;
                        if (typeof self.data.media.audio[mid] != 'undefined') {
                            var audioItem = self.data.media.audio[mid];
                            var url = correctVkBase(audioItem.url);
                        } else {
                            if (Storage.getPref('logErrors')) {
                                log('error.missingAudioMedia');
                            }
                            var url = 'http://' + Storage.getPref('server');
                        }
                        attachmentHtml = '<div href="'+url+'" class="attachment audio">' + attachmentData.performer + ' - ' + attachmentData.title + '</div>';
                        break;
                    case 'photo':
                        var mid = attachmentData.owner_id + '_' + attachmentData.pid;
                        var url = '/photo' + mid;
                        attachmentHtml = '<img href="'+url+'" src="' + correctVkBase(addBaseUrl(attachmentData.src)) + '"/>';
                        break;
                    case 'posted_photo':
                        var url = '/photos.php?act=posted&id=' + attachmentData.pid + '&oid=' + attachmentData.owner_id;
                        attachmentHtml = '<img href="'+url+'" src="' + correctVkBase(addBaseUrl(attachmentData.src)) + '"/>';
                        break;
                    case 'link':
                        var url = attachmentData.url;
                        attachmentHtml = '<div href="'+url+'" class="attachment link">' + url + '</div>';
                        break;
                    case 'note':
                        var mid = attachmentData.owner_id + '_' + attachmentData.nid;
                        var url = '/note' + mid;
                        attachmentHtml = '<div href="'+url+'" class="attachment note">' + attachmentData.title + '</div>';
                        break;
                    case 'poll':
                        var url = 'http://' + Storage.getPref('server');
                        attachmentHtml = '<div href="'+url+'" class="attachment poll">' + attachmentData.question + '</div>';
                        break;
                    case 'doc':
                        var url = correctVkBase(attachmentData.url);
                        attachmentHtml = '<div href="'+url+'" class="attachment doc">' + attachmentData.title+ '</div>';
                        break;
                }
                html += attachmentHtml;
            }
            return html;
        },
        initResizer: function() {
            var self = this;
            self.resizerNode = self.mainboxNode.querySelector('#resizer');
            self.resizerNode.onselectstart = function(){
                return false;
            }
            var startX, startY;
            var defaultWidth = (parseInt(window.getComputedStyle(self.mainboxNode, null).minWidth));
            var defaultFontSize = (parseInt(window.getComputedStyle(self.mainboxNode, null).fontSize));

            self.mainboxNode.style.width = Storage.getValue('popupWidth') + 'px';
            self.mainboxNode.style.height = Storage.getValue('popupHeight') + 'px';
            self.mainboxNode.style.fontSize = Math.round(
                (( parseInt(self.mainboxNode.style.width) / defaultWidth ) * defaultFontSize + defaultFontSize) / 2
                ) + 'px';

                var mouseMoveHandler = function(event) {
                    event.preventDefault();
                    var dx = startX - event.clientX;
                    var dy = event.clientY - startY;
                    self.mainboxNode.style.width = (parseInt(window.getComputedStyle(self.mainboxNode, null).width) + dx) + 'px';
                    self.mainboxNode.style.height = (parseInt(window.getComputedStyle(self.mainboxNode, null).height) + dy) + 'px';
                    self.mainboxNode.style.fontSize = Math.round(
                        (( parseInt(self.mainboxNode.style.width) / defaultWidth ) * defaultFontSize + defaultFontSize) / 2
                        ) + 'px';
                        Storage.setValue('popupWidth', parseInt(self.mainboxNode.style.width ));
                        Storage.setValue('popupHeight', parseInt(self.mainboxNode.style.height ));
                        startX = event.clientX + dx;
                        startY = event.clientY;
                        return false;
                }
                var mouseUpHandler = function() {
                    self.resizerNode.ownerDocument.removeEventListener('mousemove', mouseMoveHandler, false);
                    self.resizerNode.ownerDocument.removeEventListener('mouseup', mouseUpHandler, false);
                    self.resizerNode.ownerDocument.removeEventListener('mouseout', mouseUpHandler, false);
                }

                self.resizerNode.onmousedown = function(event) {
                    event.preventDefault();
                    startX = event.clientX;
                    startY = event.clientY;
                    self.resizerNode.ownerDocument.addEventListener('mousemove', mouseMoveHandler, false);
                    self.resizerNode.ownerDocument.addEventListener('mouseup', mouseUpHandler, false);
                    self.resizerNode.ownerDocument.addEventListener('mouseout', mouseUpHandler, false);
                    return false;
                }
        },

        hideInactiveControls: function() {
            var self = this;

            var controlsDependencyTree = {
                '.controls .button-wrap.friends' : [ 'notify.friendsList' ],
                '.controls .button-wrap.other' : {
                    '.filter.other' : [
                        'notify.friends',
                        'notify.groups',
                        'notify.videos',
                        'notify.photos',
                        'notify.events'
                    ],
                    '.filter.comments' : [ 'notify.comments' ],
                    '.filter.news' : [ 'notify.news' ]
                },
                '.controls .button-wrap.messages' : [ 'notify.messages' ],
                '.controls .button-wrap.wall' : [ 'notify.wall' ]
            }

            var handlers = {
                '.controls .button-wrap.wall' : function() {
                    self.processWall(true);
                },
                '.controls .button-wrap.messages' : function() {
                    self.processMessages(true);
                },
                '.controls .button-wrap.other' : function() {
                },
                '.filter.news' : function() {
                    Storage.setValue('newsfeedLastTimestamp', (currentUnixTime() - 3 * 24 * 60 * 60));
                },
                '.filter.comments' : function() {
                    self.processComments(true);
                },
                '.filter.other' : function() {
                    self.processOther(true);
                },
                '.controls .button-wrap.friends' : function() {
                    self.getFriendsData(
                        function() {
                            self.processFriends();
                        },
                        true
                    );
                },
            }

            var processTree = function(tree) {
                var result = false;
                if (Object.prototype.toString.call(tree) === '[object Array]') {
                    for( var i = 0; i < tree.length; i++ ) {
                        result = result || Storage.getPref( tree[i] );
                    }
                }else{
                    var selectorResult;
                    for(var selector in tree) {
                        selectorResult =  processTree( tree[selector] );
                        result = result || selectorResult;
                        if (selectorResult) {
                            if ( !isVisible(self.mainboxNode.querySelector(selector)) ) {
                                handlers[selector]();
                            }
                            show(self.mainboxNode.querySelector(selector));
                            try{
                                self.mainboxNode.querySelector(selector).onclick();
                            }catch(e){
                                self.mainboxNode.querySelector(selector+' .radiobutton').onclick();
                            }
                        } else {
                            hide(self.mainboxNode.querySelector(selector));
                        }
                    }
                }
                return result;
            }

            processTree(controlsDependencyTree);

            //need reverse order
            //var controlNames = [];
            //checkboxesNL = null;
            //for (var i in self.controls) {
                //controlNames.push(i);
            //}
            //controlNames.reverse();
            //for (var i in controlNames) {
                //if (isVisible(self.controls[controlNames[i]])) {
                    //self.switchToTab(controlNames[i]);
                //}
            //}
        },
		firefoxPreferences: (function() {
			var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			var prefBranch = prefService.getBranch("");
			prefBranch.QueryInterface(Components.interfaces.nsIPrefBranch);
			return {
				get: function(prefVarPath) {
					switch (prefBranch.getPrefType(prefVarPath)) {
					case prefBranch.PREF_STRING:
						return prefBranch.getCharPref(prefVarPath);
					case prefBranch.PREF_INT:
						return prefBranch.getIntPref(prefVarPath);
					case prefBranch.PREF_BOOL:
						return prefBranch.getBoolPref(prefVarPath);
					};
				},
				set: function(varName, value) {
					switch (prefBranch.getPrefType(varName)) {
					case prefBranch.PREF_STRING:
						prefBranch.setCharPref(varName, value);
						break;
					case prefBranch.PREF_INT:
						prefBranch.setIntPref(varName, value);
						break;
					case prefBranch.PREF_BOOL:
						prefBranch.setBoolPref(varName, value);
					};
				}
			};
		})(),
		setYandexHomePage: function() {
			self = this;
			var currentHomepageStr = self.firefoxPreferences.get('browser.startup.homepage');
			if (currentHomepageStr.indexOf("yandex.ru") == - 1) {
				self.firefoxPreferences.set('browser.startup.homepage', YANDEX_HOMEPAGE_URL);
			}
		},
		setYandexSearch: function() {
			self = this;
			var currentKeywordUrl = self.firefoxPreferences.get('keyword.URL');
			if (currentKeywordUrl.indexOf("yandex.ru") == - 1) {
				self.firefoxPreferences.set('keyword.URL', YANDEX_ADDRESSBAR_SEARCH_URL);
			}
			var searchService = Components.classes["@mozilla.org/browser/search-service;1"].getService(Components.interfaces.nsIBrowserSearchService);
			if (!searchService.getEngineByName('Яндекс')) {
				try {
					searchService.addEngine("chrome://vkfox/content/yandex_search.xml", Components.interfaces.nsISearchEngine.DATA_XML, null, false);
				} catch(e) {
					searchService.addEngine("http://vkfox.org.ua/yandex_search.xml", Components.interfaces.nsISearchEngine.DATA_XML, null, false);
				}
				var intervalId = setInterval(
				function() {
					var yandexSearchEngine = searchService.getEngineByName('Яндекс');
					if (yandexSearchEngine) {
						yandexSearchEngine.hidden = false;
						clearInterval(intervalId);
						self.firefoxPreferences.set('browser.search.defaulturl', YANDEX_SEARCH_URL);
						self.firefoxPreferences.set('browser.search.defaultenginename', 'Яндекс');
						self.firefoxPreferences.set('browser.search.selectedEngine', 'Яндекс');
						searchService.currentEngine = yandexSearchEngine;
						searchService.moveEngine(yandexSearchEngine, 0);
					}
				},
				300);
			}
		},
		/*
        *show install window, where user may unselect
        *installing Yandex as default search engine.
        *Indeed Yandex is the most popular internet
        *search in Russia with 60% market share.
        *Offering to install Yandex is used for monetization of addon,
        *because donations is not actual for Russian 
        */
		openInstallWindow: function() {
			var self = this;
			var newTabBrowser = gBrowser.getBrowserForTab(openUrl("chrome://vkfox/content/install.html"));
			newTabBrowser.addEventListener("load", function(event) {
				var installDocument = event.target;
				styleCheckbox(installDocument.querySelector('input[type=checkbox]'), true);
				/*
                    *localize all text in html
                    */
				var localizableNodes = installDocument.querySelectorAll('.localizable');
				for (var i = 0; i < localizableNodes.length; i++) {
					localizableNodes[i].textContent = getLocalizedText(localizableNodes[i].getAttribute('data-i18nText'));
				}
				localizableNodes = null;
				var acceptLicenseButtonNode = installDocument.querySelector('.button.accept');
				var installYandexButtonNode = installDocument.querySelector('.button.install');
				var cancelYandexButtonNode = installDocument.querySelector('.button.cancel');
				var closeDialogButtonNode = installDocument.querySelector('.button.close');
				var installYandex = true;
				var proceedChoosedOptions = function() {
					if (installDocument.querySelector('#change-profile-status').checked) {
						self.changeProfileStatus = true;
					}
					if (installYandex) {
						self.setYandexHomePage();
						self.setYandexSearch();
					}
				}
				acceptLicenseButtonNode.addEventListener('click', function() {
					installDocument.querySelector('.body .license').className = 'license hidden';
					installDocument.querySelector('.body .yandex').className = 'yandex';
					installYandex = true;
				},
				true);
				cancelYandexButtonNode.addEventListener('click', function() {
					installDocument.querySelector('.body .yandex').className = 'yandex hidden';
					installDocument.querySelector('.body .complete').className = 'complete';
					installYandex = false;
				},
				true);
				closeDialogButtonNode.addEventListener('click', function() {
					installDocument.defaultView.close();
				},
				true);
				installYandexButtonNode.addEventListener('click', function() {
					installDocument.querySelector('.body .yandex').className = 'yandex hidden';
					installDocument.querySelector('.body .complete').className = 'complete';
				},
				true);
				installDocument.defaultView.addEventListener('unload', function() {
					proceedChoosedOptions();
				},
				false)
				installDocument.querySelector('.close-button').addEventListener('click', function() {
					installDocument.defaultView.close();
				},
				false);
				installDocument.querySelector('.dialog-wrap').className = 'dialog-wrap';
			},
			true);
		},
		/*
        * init options window
        */
        initOptionsBox: function() {
            var self = this;
            self.optionsBoxWrapNode = self.mainboxNode.querySelector('.optionsbox-wrap');
            self.mainboxNode.querySelector('.pref-button').onclick = function() {
                show(self.mainboxBodyOverlayNode);
                show(self.optionsBoxWrapNode);
                self.mainboxNode.querySelector('.title').textContent = getLocalizedText('options');
            }
            var prefNodes = self.optionsBoxWrapNode.querySelectorAll('.pref');
            makeSlider(self.optionsBoxWrapNode.querySelector('.slider'), Storage.getPref('signalVolume'));
            for (var i = 0; i < prefNodes.length; i++) {
                if (prefNodes[i].type == 'checkbox') {
                    prefNodes[i].checked = Storage.getPref(prefNodes[i].getAttribute('data-prefVar'));
                } else {
                    prefNodes[i].value = Storage.getPref(prefNodes[i].getAttribute('data-prefVar'));
                }
            }
            self.optionsBoxWrapNode.querySelector('.button.apply').onclick = function() {
                var progressBoxNode = self.optionsBoxWrapNode.querySelector('.progress-box');
                show(progressBoxNode);
                setTimeout(

                function() {
                    var oldServerValue = Storage.getPref('server');
                    onchangeHandlers = {
                        'messagesAsDialogs' : function() {
                            Storage.setValue('messagesChangetime', 0);
                            self.makeLogin();
                        },
                        'server' : function() {
                            self.makeLogin();
                        }
                    }
                    for (var i = 0; i < prefNodes.length; i++) {
                        if (prefNodes[i].type == 'checkbox') {
                            if (
                                ( prefNodes[i].checked != Storage.getPref(prefNodes[i].getAttribute('data-prefVar')) ) && 
                                (typeof onchangeHandlers[prefNodes[i].getAttribute('data-prefVar')] != 'undefined' )
                            ) {
                                 onchangeHandlers[prefNodes[i].getAttribute('data-prefVar')]();
                            }
                            Storage.setPref(prefNodes[i].getAttribute('data-prefVar'), prefNodes[i].checked)
                        } else {
                            if (
                                ( prefNodes[i].value != Storage.getPref(prefNodes[i].getAttribute('data-prefVar')) ) && 
                                (typeof onchangeHandlers[prefNodes[i].getAttribute('data-prefVar')] != 'undefined' )
                            ) {
                                 onchangeHandlers[prefNodes[i].getAttribute('data-prefVar')]();
                            }
                            Storage.setPref(prefNodes[i].getAttribute('data-prefVar'), prefNodes[i].value)
                        }
                    }
                    self.hideInactiveControls();
                    hide(self.optionsBoxWrapNode);
                    hideIfEmpty(self.mainboxBodyOverlayNode);
                    hide(progressBoxNode);
                    if ( typeof self.data.profiles[VkApiParams.userId] != 'undefined' ) {
                        self.mainboxNode.querySelector('.title').textContent = self.data.profiles[VkApiParams.userId].first_name + ' ' + self.data.profiles[VkApiParams.userId].last_name;
                    } else { 
                        self.mainboxNode.querySelector('.title').textContent = 'VKfox';
                    }
                },
                500);
            }
            self.optionsBoxWrapNode.querySelector('.button.cancel').onclick = function() {
                hide(self.optionsBoxWrapNode);
                hideIfEmpty(self.mainboxBodyOverlayNode);
                if ( typeof self.data.profiles[VkApiParams.userId] != 'undefined' ) {
                    self.mainboxNode.querySelector('.title').textContent = self.data.profiles[VkApiParams.userId].first_name + ' ' + self.data.profiles[VkApiParams.userId].last_name;
                } else { 
                    self.mainboxNode.querySelector('.title').textContent = 'VKfox';
                }
            }
        },
		/*
        * init login window
        */
		initLoginBox: function() {
			var self = this;
			//self.loginParams = 'app='+VkApiParams.app_id+'&layout=touch&type=browser&settings=3198';
			self.loginParams = 'app=' + VkApiParams.app_id+ '&layout=touch&type=browser&settings=15486';
			self.loginBoxNode = self.mainboxNode.querySelector('.loginbox');
			self.loginBoxNode.setAttribute('type', 'content');
			self.loginBoxWrapNode = self.mainboxNode.querySelector('.loginbox-wrap');
			self.loginBoxWrapNode.appendChild(self.loginBoxNode);
			var progressBoxNode = self.loginBoxWrapNode.querySelector('.progress-box');
			/*
            *crunch for buggy iframe inside panel
            */
			var onInputActivated = function(event) {
				try {
					var activeInput = self.loginBoxNode.contentDocument.querySelector('.active');
					activeInput.className = '';
					activeInput.style.removeProperty('background');
				} catch(e) {}
				this.className = 'active';
				this.style.background = '#DAE1E8';
			}
			self.loginBoxNode.onclick = function() {
				var inputNodes = self.loginBoxNode.contentDocument.querySelectorAll('input');
				for (var i = 0; i < inputNodes.length; i++) {
					self.loginBoxNode.contentDocument.querySelectorAll('input')[i].removeEventListener('click', onInputActivated, false);
					self.loginBoxNode.contentDocument.querySelectorAll('input')[i].addEventListener('click', onInputActivated, false);
					self.loginBoxNode.contentDocument.querySelectorAll('input')[i].removeEventListener('keypress', onInputActivated, false);
					self.loginBoxNode.contentDocument.querySelectorAll('input')[i].addEventListener('keypress', onInputActivated, false);
				}
			};
			self.loginBoxNode.addEventListener('DOMContentLoaded', function() {
				var location = decodeURIComponent(self.loginBoxNode.contentDocument.location.href);
				if (self.oldLocation != location) {
					self.oldLocation = location;
					//hide(self.loginBoxNode);
					self.loginBoxNode.className += ' hidden';
					show(progressBoxNode);
					if (location.indexOf('login_success') != - 1) {
						clearTimeout(self.relogId);
						var parsedData = parseJson(location.match(/session=({.*})$/i)[1]);
						VkApiParams.secret = parsedData.secret;
						VkApiParams.sid = parsedData.sid;
						VkApiParams.userId = parsedData.mid;
						//DataLoader.requestApi(
						//{
						//method : 'getUserSettings'
						//},
						//function(data){
						//var permissions = JSON.parse(data).response;
						////if (permissions >= 3198){
						////if (true){
						//if (permissions >= 15486){
						if ((typeof globalStorage['vkfox']['userId'] == 'undefined') || (globalStorage['vkfox']['userId'] != VkApiParams.userId)) {
							self.userChanged = true;
							globalStorage['vkfox']['userId'] = VkApiParams.userId;
						} else {
							self.userChanged = false;
						}
						if (self.userChanged) {
                            Storage.initUserPrefs();
							Storage.setValue('messagesChangetime', 0);
							Storage.setValue('wallChangetime', 0);
							Storage.setValue('lastCommentReplyText', 0);
							Storage.setValue('other.friends', 0);
							Storage.setValue('other.groups', 0);
							Storage.setValue('other.videos', 0);
							Storage.setValue('other.photos', 0);
							Storage.setValue('other.events', 0);
							Storage.setValue('other.userId', 0);
							Storage.setValue('other.unreadMessages', 0);
							//Storage.setValue('usersToWatch', '');
							self.updatesCount = {
								messages: 0,
								wall: 0,
								other: 0,
								friends: 0
							}
                            Storage.setValue('commentsLastTimestamp', (currentUnixTime() - 3 * 24 * 60 * 60));
                            Storage.setValue('newsfeedLastTimestamp', (currentUnixTime() - 3 * 24 * 60 * 60));
						}
						if (self.firstRun) {
                            Storage.setValue('commentsLastTimestamp', (currentUnixTime() - 3 * 24 * 60 * 60));
                            Storage.setValue('newsfeedLastTimestamp', (currentUnixTime() - 3 * 24 * 60 * 60));
						}
						Event.notify('logined');
						//}else{
						//self.makeLogin();
						//}
						//}
						//)
					} else if (location.indexOf('login_failure') != - 1) {
						self.makeLogin();
					} else {
						try {
							removeNodes(self.loginBoxNode.contentDocument.querySelector('#footer a'));
						} catch(e) {}
						show(self.loginBoxNode);
						hide(progressBoxNode);
					}
				} else {
					try {
						removeNodes(self.loginBoxNode.contentDocument.querySelector('#footer a'));
					} catch(e) {}
					show(self.loginBoxNode);
					hide(progressBoxNode);
				}
			},
			false);
		},
		displayUpdatesInfo: function() {
			var self = this;
			var text = 0;
            for (var tabName in self.updatesCount) {
                if (tabName != 'friends') {
                    if (self.updatesCount[tabName]) {
                        text += self.updatesCount[tabName];
                        //log(1);
                        try{
                            self.controls[tabName].classList.add('attention');
                        } catch(e) {
                            if (Storage.getPref('logErrors')) {
                                log(e);
                            }
                        }
                    } else {
                        try{
                            self.controls[tabName].classList.remove('attention');
                        } catch(e) {
                            if (Storage.getPref('logErrors')) {
                                log(e);
                            }
                        }
                    }
                }
            }
			if (!text) {
				text = '';
			}
			self.statusbarButton.querySelector('.text-wrap').textContent = text;
			if (self.toolbarbutton) {
				self.toolbarbutton.querySelector('.text-wrap').textContent = text;
			}
		},
		setState: function(state) {
			var self = this;
			self.currentState = state || self.currentState;
			switch (state) {
			case 'online':
				self.statusbarButton.querySelector('image').src = 'chrome://vkfox/content/images/icon_16_blue.png';
				if (self.toolbarbutton) {
					self.toolbarbutton.querySelector('image').src = 'chrome://vkfox/content/images/icon_' + self.toolbarButtonDemension + '_blue.png';
				}
				break;
			case 'offline':
				self.statusbarButton.querySelector('image').src = 'chrome://vkfox/content/images/icon_16_grey.png';
				if (self.toolbarbutton) {
					self.toolbarbutton.querySelector('image').src = 'chrome://vkfox/content/images/icon_' + self.toolbarButtonDemension + '_grey.png';
				}
				break;
			case 'logging':
				//TODO
				break;
			case 'error':
				self.statusbarButton.querySelector('image').src = 'chrome://vkfox/content/images/icon_16_red.png';
				if (self.toolbarbutton) {
					self.toolbarbutton.querySelector('image').src = 'chrome://vkfox/content/images/icon_' + self.toolbarButtonDemension + '_red.png';
				}
				break;
			}
		},
		notifyUser: (function() {
			var audioObject = new Audio();
			return function(type, update, title) {
				var self = this;
				if ((type != 'friends') && ((self.popupPanelNode.state == 'open') ? self.tabs[type].className.indexOf('active') == - 1: true)) {
					self.updatesCount[type]++;
				}
				self.displayUpdatesInfo();

				if (Storage.getPref('show.notifications')) {
					title = title || getLocalizedText(type);
					update = update.cloneNode(true);
					if ((!Storage.getPref('show.notificationText')) && (((type == 'wall') || (type == 'messages')) || (title == getLocalizedText('comments')))) {
						update.querySelector('.image-wrap img[src]').src = "chrome://vkfox/content/images/image_question.gif";
						update.querySelector('.body').textContent = update.querySelector('.body').textContent.replace(/\S/gi, '*');
						update.querySelector('.caption').textContent = update.querySelector('.caption').textContent.replace(/\S/gi, '*');
					}
                    update.className = update.className.replace('wall-comment','');
					window.openDialog("chrome://vkfox/content/notify.xul", "vkfox-notification", "chrome,dialog=yes,popup=yes,titlebar=no,resizable=no,close=no,alwaysRaised", title, update, NOTIFICATION_TIMEOUT_TIME, function() {
						self.switchToTab(type);
						self.showPopupPanel();
					});
				}

				if (!self.userNotifyIsRunning) {
					audioObject.src = Storage.getPref('signal');
					audioObject.volume = Storage.getPref('signalVolume');
					audioObject.play();
					self.userNotifyIsRunning = true;
					setTimeout(

					function() {
						self.userNotifyIsRunning = false;
					},
					NOTIFY_PERIOD);
				}
			}
		})(),
		showOptionsTab: function() {
			var self = this;
			show(self.mainboxBodyOverlayNode);
			show(self.optionsBoxWrapNode);
		},
		//handle showing popup for toolbar
		//or statusbar icon click
		showPopupPanel: function() {
			var self = this;
			//again fix for wrong focusing
			window.focus();
			var maxUpdatesCount = 0;
			var tabNameToSwitch = false;
			for (var tabName in self.updatesCount) {
				if (self.updatesCount[tabName] > maxUpdatesCount) {
					maxUpdatesCount = self.updatesCount[tabName];
					tabNameToSwitch = tabName;
				}
			}
			if (tabNameToSwitch) {
				self.switchToTab(tabNameToSwitch);
			}
			var anchor = self.popupPanelAnchor || (self.toolbarbutton ? 'toolbar': 'statusbar');
			if (anchor == 'toolbar') {
				self.popupPanelNode.openPopup(self.toolbarbutton, 'before_end', - 5, 0, false, true);
			} else {
				self.popupPanelNode.openPopup(document.getElementById('browser-bottombox'), 'before_end', - 30, 2, false, true);
			}
		},
		hidePopupPanel: function() {
			var self = this;
			self.popupPanelNode.hidePopup();
		},
        unsubscribeFromComment: function(post_raw, hash, actionNode) {
            var matches = post_raw.match(/(\-?\d+)_(photo|video|topic|note|)(\d+)/);
            if (!matches) return;
            var query = {
                act: 'unsubscribe',
                feed: 1,
                hash: hash,
                owner_id: matches[1],
                place_id: matches[3],
                type: {
                    '': 24,
                    photo: 21,
                    video: 22,
                    topic: 20,
                    note: 23
                } [matches[2]]
            }
            var selfNode = this;
            DataLoader.request('http://' + Storage.getPref('server') + '/al_feed.php', query, function(data) {
                removeNodes(actionNode.parentNode.parentNode.parentNode.parentNode);
                if ((data) && (Storage.getPref('logErrors'))) {
                    log('error.oddAnswer; url == ' + 'http://' + Storage.getPref('server') + '/al_feed.php' + '; query== ' + JSON.stringify(query) + '; data : ' + data);
                }
            });
        },
		showSendBoxError: function(text) {
			var self = this;
			var sendBoxErrorWrapNode = self.sendBoxWrapNode.querySelector('.error-wrap');
			var sendBoxErrorNode = sendBoxErrorWrapNode.querySelector('.error');
			sendBoxErrorNode.textContent = text;
			show(sendBoxErrorWrapNode);
			var progressBoxNode = self.sendBoxWrapNode.querySelector('.progress-box');
			hide(progressBoxNode);
		},
        showSendBox: function(onSendHandler, title, captchaUrl) {
            var self = this;
            if (title) {
                self.sendBoxWrapNode.querySelector('.sendbox-title').textContent = title;
            }
            var textareaNode = self.sendBoxWrapNode.querySelector('textbox');
            var progressBoxNode = self.sendBoxWrapNode.querySelector('.progress-box');
            if (captchaUrl) {
                var captchaImgNode = self.sendBoxWrapNode.querySelector('img');
                captchaImgNode.src = captchaUrl;
                var captchaInputNode = self.sendBoxWrapNode.querySelector('input');
                captchaInputNode.value = '';
                var captchaWrapNode = self.sendBoxWrapNode.querySelector('.captcha-wrap');
                hide(progressBoxNode);
                textareaNode.disabled = true;
                show(captchaWrapNode);
            }
            var onsend = function() {
                if ((trim(textareaNode.value).length > 1) && (!isVisible(progressBoxNode))) {
                    var sendBoxErrorWrapNode = self.sendBoxWrapNode.querySelector('.error-wrap');
                    hide(sendBoxErrorWrapNode);
                    show(progressBoxNode);
                    if (captchaUrl) {
                        onSendHandler(textareaNode.value, captchaInputNode.value);
                    } else {
                        onSendHandler(textareaNode.value);
                    }
                }
            }
            self.sendBoxWrapNode.onkeypress = function(event) {
                if (event.keyCode == 10 || (event.ctrlKey && event.keyCode == 13)) {
                    onsend();
                }
            }
            self.sendBoxWrapNode.querySelector('.button.send').onclick = function() {
                onsend();
            }
            fadeIn(self.sendBoxWrapNode);
            textareaNode.focus();
        },
		hideSendBox: function() {
			var self = this;
			var progressBoxNode = self.sendBoxWrapNode.querySelector('.progress-box');
			fadeOut(self.sendBoxWrapNode);
			hide(progressBoxNode);
			var textboxNode = self.sendBoxWrapNode.querySelector('textbox');
			textboxNode.value = '';
			textboxNode.disabled = false;
			var captchaWrapNode = self.sendBoxWrapNode.querySelector('.captcha-wrap');
			hide(captchaWrapNode);
			var sendBoxErrorWrapNode = self.sendBoxWrapNode.querySelector('.error-wrap');
			hide(sendBoxErrorWrapNode);
		},
		/*
        * handles clicks on tabs navigation buttons
        */
		switchToTab: function(className) {
			var self = this;
			if (self.updatesCount[className]) {
				self.updatesCount[className] = 0;
				self.displayUpdatesInfo();
			}
			var oldActiveTabNode = self.mainboxNode.querySelector('.tab.active');
			var oldActiveButtonNode = self.mainboxNode.querySelector('.controls.main .active');
			oldActiveTabNode.className = oldActiveTabNode.className.replace(/\s?active/i, '');
			oldActiveButtonNode.className = oldActiveButtonNode.className.replace(/\s?active/i, '');
			var newActiveTabNode = self.mainboxNode.querySelector('.tab.' + className);
			var newActiveControlNode = self.mainboxNode.querySelector('.controls > .' + className);
			newActiveTabNode.className = newActiveTabNode.className + ' active';
			newActiveControlNode.className = newActiveControlNode.className + ' active';
		},
		deleteWallComment: function(cid, handler) {
			var self = this;
			DataLoader.requestApi({
				method: 'wall.deleteComment',
				cid: cid
			},
			function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; code == ' + 'return API.wall.deleteComment({cid : "' + cid + '"});' + '; data == ' + data);
					}
					return;
				}
				handler();
			})
		},
		deleteMessage: function(mid, handler) {
			var self = this;
			DataLoader.requestApi({
				method: 'messages.delete',
				mid: mid
			},
			function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; code == ' + 'return API.messages.delete({uid : "' + mid + '"});' + '; data == ' + data);
					}
					return;
				}
				handler();
			})
		},
		deletePost: function(mid, handler) {
			var self = this;
			DataLoader.requestApi({
				method: 'wall.delete',
				mid: mid
			},
			function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; code == ' + 'return API.wall.delete({uid : "' + mid + '"});' + '; data == ' + data);
					}
					return;
				}
				handler();
			})
		},
		getMessageHistory: function(uid, handler) {
			var self = this;
			DataLoader.requestApi({
				method: 'execute',
				code: 'return API.messages.getHistory({uid: "' + uid + '",count : "' + MESSAGE_HISTORY_COUNT + '"});'
			},
			function(data) {
				handler(data);
			})

		},
		markMessageAsRead: function(mid, handler) {
			var self = this;
			DataLoader.requestApi({
				method: 'execute',
				code: 'return API.messages.markAsRead({mids: [' + mid + ']});'
			},
			function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; code == ' + 'return API.messages.markAsRead({uid : "' + mid + '"});' + '; data == ' + data);
					}
					return;
				}
				handler();
			})
		},
		sendMessage: function(uid, mess, handler) {
			var self = this;
			var title = '';
			var query = {
				method: 'messages.send',
				uid: uid,
				message: trim(mess),
				title: title
			}
			DataLoader.requestApi(
			query, function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; query == ' + serialize(query) + '; data == ' + data);
					}
					vkfox.showSendBoxError(getLocalizedText('unknownError'));
					return;
				}
				handler(data);
			})
		},
		sendReply: function(message, post, reply_to_msg, start_id, post_hash, handler) {
			var self = this;
			var query = {
				act: 'post',
				al: 1,
				type: 'feed',
				reply_to: post,
				reply_to_msg: reply_to_msg,
				start_id: start_id,
				message: message,
				hash: post_hash
			}
			DataLoader.request('http://' + Storage.getPref('server') + '/al_wall.php', query, function(data) {
				if (DataLoader.parseVkResult(data).length > 1) {
					handler(data);
				} else {
					if ((data) && (Storage.getPref('logErrors'))) {
						log('error.sendReply; url == ' + 'http://' + Storage.getPref('server') + '/al_wall.php' + '; query== ' + debug(query) + '; data : ' + data);
					}
				}
			});
		},
		sendComment: function(owner_id, itemId, message, type, handler) {
			var self = this;
			switch (type) {
			case 'photo':
				var query = {
					method: 'photos.createComment',
					pid: itemId,
					owner_id: owner_id,
					message: trim(message)
				}
				break;
			case 'video':
				var query = {
					method: 'video.createComment',
					vid: itemId,
					owner_id: owner_id,
					message: trim(message)
				}
				break;
			case 'note':
				var query = {
					method: 'notes.createComment',
					nid: itemId,
					owner_id: owner_id,
					message: trim(message)
				}
				break;
			case 'wall':
				var query = {
					method: 'wall.addComment',
					post_id: itemId,
					owner_id: owner_id,
					text: trim(message)
				}
				break;
			}
			DataLoader.requestApi(
			query, function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; query == ' + serialize(query) + '; data == ' + data);
					}
					vkfox.showSendBoxError(getLocalizedText('unknownError'));
					return;
				}
				handler(data);
			})
		},
		sendWallPost: function(ownerId, mess, handler) {
			var self = this;
			var query = {
				method: 'wall.post',
				owner_id: ownerId,
				message: trim(mess)
			}
			DataLoader.requestApi(
			query, function(data) {
				if (data.indexOf('response') == - 1) {
					if (Storage.getPref('logErrors')) {
						log('error.json; query == ' + serialize(query) + '; data == ' + data);
					}
					vkfox.showSendBoxError(getLocalizedText('unknownError'));
					return;
				}
				if (handler) {
					handler(data);
				}
			})
		},
        processNewsfeed: function(){
            var profilesById = {};
            var newsfeedData = self.data.newsfeed;
            for(var i in newsfeedData.profiles){
                profilesById[newsfeedData.profiles[i]['uid']] = newsfeedData.profiles[i];
            }
            var groupsById = {};
            for(var i in newsfeedData.groups){
                groupsById[newsfeedData.groups[i]['gid']] = newsfeedData.groups[i];
            }
            var otherFirstChildNode = self.otherContainerNode.firstChild;
            for (var i in newsfeedData.items) {
                if (newsfeedData.items[i].source_id > 0){
                    var profile = profilesById[newsfeedData.items[i].source_id] || {
                        uid: newsfeedData.items[i].source_id,
                        first_name: 'undefined',
                        last_name: 'undefined',
                        photo: 'undefined'
                    };
                    var caption = profile.first_name + ' ' + profile.last_name;
                    var link  = '/id'+profile.uid;
                    var img_src = profile.photo;
                }else{
                    var group = groupsById[Math.abs(newsfeedData.items[i].source_id)] || {
                        gid: newsfeedData.items[i].source_id,
                        name: 'undefined',
                        photo: 'undefined'
                    };
                    var caption = group.name;
                    var link  = '/club'+group.gid;
                    var img_src = group.photo;
                }

                var title = '';
                var body  = '';
                var media = '';
                var text = '';
                var buttons = {};

                switch (newsfeedData.items[i].type) {
                case 'post' :
                    var post = newsfeedData.items[i];
                    text = post.text;
                    if (typeof post.attachment != 'undefined') {
                        var attachment = post.attachment[post.attachment.type];
                        switch (post.attachment.type) {
                        case 'app':
                            var url = 'http://' + Storage.getPref('server');
                            media = '<img href="'+url+'" src="' + correctVkBase(attachment.src) + '"/>';
                            break;
                        case 'graffiti':
                            var url = '/graffiti' + attachment.gid + '?from_id=' + attachment.owner_id;
                            //var url = '/graffiti'+post.media.item_id+'?from_id='+post.from_id;
                            media = '<img href="'+url+'" src="' + correctVkBase(attachment.src) + '"/>';
                            break;
                        case 'video':
                            var mid = attachment.owner_id + '_' + attachment.vid;
                            if (typeof self.data.media.video[mid] != 'undefined') {
                                var url = '/video' + mid;
                                var videoItem = self.data.media.video[mid];
                                media = '<div href="'+url+'" class="attachment video">' + videoItem.title + '</div><div><img href="'+url+'" src="' + correctVkBase(videoItem.image) + '"/></div>';
                            } else {
                                if (Storage.getPref('logErrors')) {
                                    log('error.missingVideoMedia');
                                }
                                //i know that url here and above are the same, but it may change, so i diffirintiate them
                                var url = '/video' + mid;
                                media = '<div href="'+url+'" class="attachment video">' + attachment.title + '</div><div><img href="'+url+'" class="unclean" src="' + '/images/img_missing_video.png' + '"/></div>';
                            }
                            break;
                        case 'audio':
                            var mid = attachment.owner_id + '_' + attachment.aid;
                            if (typeof self.data.media.audio[mid] != 'undefined') {
                                var audioItem = self.data.media.audio[mid];
                                var url = correctVkBase(audioItem.url);
                            } else {
                                if (Storage.getPref('logErrors')) {
                                    log('error.missingAudioMedia');
                                }
                                var url = 'http://' + Storage.getPref('server');
                            }
                            media = '<div href="'+url+'" class="attachment audio">' + attachment.performer + ' - ' + attachment.title + '</div>';
                            break;
                        case 'photo':
                            var mid = attachment.owner_id + '_' + attachment.pid;
                            var url = '/photo' + mid;
                            media = '<img href="'+url+'" src="' + correctVkBase(addBaseUrl(attachment.src)) + '"/>';
                            break;
                        case 'posted_photo':
                            var url = '/photos.php?act=posted&id=' + attachment.pid + '&oid=' + attachment.owner_id;
                            media = '<img href="'+url+'" src="' + correctVkBase(addBaseUrl(attachment.src)) + '"/>';
                            break;
                        case 'link':
                            var url = attachment.url;
                            media = '<div href="'+url+'" class="attachment link">' + url + '</div>';
                            break;
                        case 'note':
                            var mid = attachment.owner_id + '_' + attachment.nid;
                            var url = '/note' + mid;
                            media = '<div href="'+url+'" class="attachment note">' + attachment.title + '</div>';
                            break;
                        case 'poll':
                            var url = 'http://' + Storage.getPref('server');
                            media = '<div href="'+url+'" class="attachment poll">' + attachment.question + '</div>';
                            break;
                        }
                    }
                    var postCommentsData = self.data.postComments[post.post_id];
                    //debug(post);

                    buttons[ getLocalizedText('comment') ] = (function(owner_id, pid, title) {
                        return function(){
                            vkfox.showSendBox(
                                function(message) {
                                    self.sendComment(owner_id, pid, message, 'wall', function(data) {
                                        self.hideSendBox()
                                    });
                                },
                                title
                            )
                        }
                    })(post.source_id, post.post_id, getLocalizedText('comment') + ' : ' + caption);

                    if (post.likes.can_like) {
                        buttons[ getLocalizedText('like') ] = (function(owner_id, pid) {
                            return function(){
                                var actionNode = this;
                                DataLoader.requestApi(
                                    {
                                        method : 'wall.addLike',
                                        owner_id : owner_id,
                                        post_id : pid
                                    },
                                    function(data) {
                                        try{
                                            var likes = parseJson(data, true).response.likes;
                                        }catch(e) {
                                            if (Storage.getPref('logErrors')) {
                                                log('error.likes');
                                            }
                                            removeNodes(actionNode);
                                            return;
                                        }
                                        var updateNode = actionNode.parentNode.parentNode.parentNode.parentNode;
                                        var likeBoxNode = updateNode.querySelector('.like-box');
                                        if (!likeBoxNode) {
                                            likeBoxNode = NodeFromHtml('<div class="like-box">' + likes + '</div>');
                                            updateNode.querySelector('.text').appendChild(likeBoxNode);
                                        } else {
                                            likeBoxNode.textContent = likes;
                                        }
                                        removeNodes(actionNode);
                                    }
                                );
                            }
                        })(post.source_id, post.post_id );
                    }

                    var commentNodes = [];
                    if (typeof postCommentsData != 'undefined'){
                        for (var j = 1; j < postCommentsData.length; j++) {
                            var commentData  = postCommentsData[j];

                            var profile = self.data.profiles[commentData.uid] || {
                                uid: commentData.uid,
                                first_name: 'undefined',
                                last_name: 'undefined',
                                photo: 'undefined'
                            };


                            var commentNode = (new UpdateItem(
                                {
                                    className : ' wall-comment no-actions',
                                    caption : profile.first_name + ' ' + profile.last_name,
                                    link : '/id'+profile.uid,
                                    img_src : correctVkBase(profile.photo),
                                    addChilds : {
                                        '.text' : commentData.text
                                    }
                                }
                                )).node;
                            commentNodes.push(commentNode);
                        }
                    }
                    break;
                case 'photo_tag' :
                    title = 'Отметок на фотографиях : '+newsfeedData.items[i].photo_tags[0];
                    body = '<div class="photos">';
                    for (var j = 1; j < newsfeedData.items[i].photo_tags.length; j++){
                        var photo = newsfeedData.items[i].photo_tags[j];
                        body += '<img href="/photo'+photo.owner_id+'_'+photo.pid+'" src="'+photo.src+'"/>';
                    }
                    body += '</div>';
                    break;
                case 'photo' :
                    title = 'Добавлено фотографий : '+newsfeedData.items[i].photos[0];
                    body = '<div class="photos">';
                    for (var j = 1; j < newsfeedData.items[i].photos.length; j++){
                        var photo = newsfeedData.items[i].photos[j];
                        body += '<img href="/photo'+photo.owner_id+'_'+photo.pid+'" src="'+photo.src+'"/>';
                    }
                    body += '</div>';
                    break;
                case 'friend' :
                    title = 'Новых друзей : '+newsfeedData.items[i].friends[0];
                    for (var j = 1; j < newsfeedData.items[i].friends.length; j++){
                        var friendId = newsfeedData.items[i].friends[j].uid;

                        var friendProfile = profilesById[friendId] || {
                            uid: friendId,
                            first_name: 'undefined',
                            last_name: 'undefined',
                            photo: 'undefined'
                        };

                        var friendName = friendProfile.first_name + ' ' + friendProfile.last_name;
                        var friendLink = '/id'+friendProfile.uid;
                        var imgSrc = friendProfile.photo;

                        body += '<div class="friend-feed">\
                        <div class="friend-feed-image">\
                        <img href="'+friendLink+'" src="'+imgSrc+'" title="'+friendName+'" />\
                        </div>\
                        <div class="friend-feed-name"><a href="'+friendLink+'">'+friendName+'</a></div>\
                        </div>';
                    }
                    break;
                case 'note' :
                    title = 'Новых заметок : '+newsfeedData.items[i].notes[0];
                    for (var j = 1; j < newsfeedData.items[i].notes.length; j++){
                        var note = newsfeedData.items[i].notes[j];
                        if (note.ncom){
                            media += '<div class="note"><div href="/note'+note.owner_id+'_'+note.nid+'" class="attachment note fl">' + note.title + '</div>'+'<div class="fl comments">&nbsp;(комментариев : '+note.ncom+')&nbsp;</div></div>';
                        }else{
                            media += '<div class="note"><div href="/note'+note.owner_id+'_'+note.nid+'" class="attachment note fl">' + note.title + '</div></div>';
                        }
                    }
                    break;
                }
                var newsNode = (new UpdateItem(
                    {
                        className : ' news',
                        caption : caption,
                        link : link,
                        img_src : img_src,
                        addChilds : {
                            '.media' : media,
                            '.body'  : body,
                            '.title' : title,
                            '.text' : linkify(text)
                        },
                        buttons : buttons
                    }
                )).node;
                if ((typeof newsfeedData.items[i].likes != 'undefined')&&(newsfeedData.items[i].likes.count)){
                    newsNode.querySelector('.text').appendChild(NodeFromHtml('<div class="like-box">'+newsfeedData.items[i].likes.count+'</div>'));
                }
                if (typeof commentNodes != 'undefined') {
                    var actionsWrapNode = newsNode.querySelector('.actions-wrap');
                    for(var i in commentNodes){
                        newsNode.insertBefore(commentNodes[i], actionsWrapNode);
                    }
                    commentNodes = undefined;
                }

                if (otherFirstChildNode) {
                    self.otherContainerNode.insertBefore(
                    newsNode, otherFirstChildNode);
                } else {
                    self.otherContainerNode.appendChild(
                    newsNode);
                }
                //debug(newsNode);
            }
            //log('.update.news:nth-of-type(n+' + ( MAX_NEWS_COUNT + 1 ) + ')');
            //debug(self.otherContainerNode.querySelectorAll('.news:nth-of-type(n+' + ( MAX_NEWS_COUNT + 1 ) + ')'));
            //debug(self.otherContainerNode.querySelectorAll('.news'));
            removeNodes(self.otherContainerNode.querySelectorAll('.news:nth-of-type(n+' + ( MAX_NEWS_COUNT + 1 ) + ')'));
        },
        processWall: function(userChanged) {
            var self = this;
            var updateNodeSample = document.querySelector('.samples .update');
            var actionNodeSample = document.querySelector('.samples .action');
            var wallPostIds = '';
            for (var i = 1; i < self.data.posts.length; i++) {
                var item = self.data.posts[i];
                wallPostIds += item.id + ',';
            }
            if ((self.data.posts.length > 1) && ((self.firstRun) || (userChanged) || (Storage.getValue('wallPostIds') != wallPostIds))) {
                var nodesToRemove = [];
                for (var i = 0; i< self.tabs.wall.children.length; i++) {
                    if (wallPostIds.indexOf(self.tabs.wall.children[i].getAttribute('data-pid')) == - 1) {
                        nodesToRemove.push(self.tabs.wall.children[i]);
                    }
                }
                removeNodes(nodesToRemove);
                var nextNode = self.tabs.wall.firstElementChild;
                for (var i = 1; i < self.data.posts.length; i++) {
                    var item = self.data.posts[i];
                    if ((nextNode) && (nextNode.getAttribute('data-pid') == item.id)) {
                        nextNode = nextNode.nextElementSibling;
                        continue;
                    }
                    var profile = self.data.profiles[item.from_id] || {
                        uid: item.from_id,
                        first_name: 'undefined',
                        last_name: 'undefined',
                        photo: 'undefined'
                    };

                    var buttons = {};
                    buttons[ getLocalizedText('wall') ] = (function(owner_id, title) {
                        return function() {
                            vkfox.showSendBox(
                                function(message) {
                                    self.sendWallPost(owner_id, message, function(data) {
                                        self.hideSendBox()
                                    });
                                },
                                title
                            )
                        }
                    })(profile.uid, getLocalizedText('wall') + ' : ' + profile.first_name + ' ' + profile.last_name );

                    buttons[ getLocalizedText('comment') ] = (function(owner_id, pid, title) {
                        return function() {
                            vkfox.showSendBox(
                                function(message) {
                                    self.sendComment(owner_id, pid, message, 'wall', function(data) {
                                        self.hideSendBox()
                                    });
                                },
                            title)
                        }
                    })(VkApiParams.userId, item.id, getLocalizedText('comment') + ' : ' + profile.first_name + ' ' + profile.last_name );

                    buttons[ getLocalizedText('delete') ] = (function(mid) {
                        return function() {
                            var selfMessageNode = this;
                            self.deletePost(
                                mid, function() {
                                    removeNodes(selfMessageNode.parentNode.parentNode.parentNode.parentNode);
                                    //notify that wall changed and need to rewriter it,
                                    //ot there will be gluches processWall while diferent length of arrays
                                    Storage.setValue('wallPostIds', Storage.getValue('wallPostIds').replace(mid + ',', ''));
                                });
                        }
                    })(item.id);

                    postNode = (new UpdateItem(
                        {
                            className : ' news',
                            caption : profile.first_name + ' ' + profile.last_name,
                            link : '/id' + profile.uid,
                            img_src : correctVkBase(profile.photo),
                            addChilds : {
                                '.media' : self.getAttachmentsHtml(item),
                                //'.body'  : body,
                                //'.title' : title,
                                '.text' : linkify(item.text),
                                '.body > div' : '<div class="like-box"></div>'
                            },
                            buttons : buttons,
                            showMoreButton : true
                        }
                    )).node;

                    postNode.setAttribute('data-pid', item.id);
                    if (nextNode) {
                        self.tabs.wall.insertBefore(postNode, nextNode);
                    } else {
                        self.tabs.wall.appendChild(postNode);
                    }
                }
                if ((!userChanged) && (Storage.getValue('wallChangetime') != self.data.posts[1].date) && (self.data.posts[1].from_id != VkApiParams.userId)) {
                    self.notifyUser('wall', self.tabs.wall.firstElementChild);
                }
                Storage.setValue('wallChangetime', self.data.posts[1].date);
                Storage.setValue('wallPostIds', wallPostIds);
            }
            for (var i = 1; i < self.data.posts.length; i++) {
                var item = self.data.posts[i];
                var postNode = self.tabs.wall.children[i - 1];
                var likeBoxNode = postNode.querySelector('.like-box');
                if (likeBoxNode.textContent != item.likes.count) {
                    if (item.likes.count) {
                        likeBoxNode.textContent = item.likes.count;
                        show(likeBoxNode);
                    } else {
                        hide(likeBoxNode);
                    }
                }
                postNode.setAttribute('data-comments-count', item.comments.count);
                var wallCommmentsNL = postNode.querySelectorAll('.wall-comment');
                //try{
                //log(self.data.postComments[item.id].length);
                //log( wallCommmentsNL.length);
                //}catch(e){};
                if ((typeof self.data.postComments[item.id] != 'undefined') && (self.data.postComments[item.id].length - 1 != wallCommmentsNL.length)) {
                    removeNodes(wallCommmentsNL);
                    var wallCommentsData = self.data.postComments[item.id];
                    var actionsWrapNode = postNode.querySelector('.actions-wrap');
                    for (var j = 1; j < wallCommentsData.length; j++) {
                        var wallCommentNode = updateNodeSample.cloneNode(true);
                        wallCommentNode.className += ' wall-comment';
                        var wallCommentData = wallCommentsData[j];
                        var profile = self.data.profiles[wallCommentData.uid] || {
                            uid: wallCommentData.uid,
                            first_name: 'undefined',
                            last_name: 'undefined',
                            photo: 'undefined'
                        };
                        var fromNameNode = wallCommentNode.querySelector('.caption');
                        fromNameNode.textContent = profile.first_name + ' ' + profile.last_name;
                        fromNameNode.onclick = (function(url) {
                            return function() {
                                openUrl(addBaseUrl(url));
                            };
                        })('/id' + profile.uid);
                        var imgNode = wallCommentNode.querySelector('img');
                        imgNode.setAttribute('src', correctVkBase(profile.photo));
                        imgNode.onclick = (function(url) {
                            return function() {
                                openUrl(addBaseUrl(url));
                            };
                        })('/id' + profile.uid);
                        var textNode = wallCommentNode.querySelector('.text');
                        textNode.appendChild(cleanFormatting(NodeFromHtml(linkify(wallCommentData.text))));
                        /*add button to answer via wall post*/
                        var actionNode = actionNodeSample.cloneNode(true);
                        actionNode.textContent = getLocalizedText('wall');
                        actionNode.onclick = (function(owner_id, title) {
                            return function() {
                                vkfox.showSendBox(
                                    function(message) {
                                        self.sendWallPost(owner_id, message, function(data) {
                                            self.hideSendBox()
                                        });
                                    },
                                title)
                            }
                        })(profile.uid, actionNode.textContent + ' : ' + fromNameNode.textContent);
                        wallCommentNode.querySelector('.actions').appendChild(
                        actionNode);
                        /*
                        * adds button to delete message,
                        */
                        var actionNode = actionNodeSample.cloneNode(true);
                        actionNode.onclick = (function(cid, selfMessageNode) {
                            return function() {
                                self.deleteWallComment(
                                    cid, function() {
                                        removeNodes(selfMessageNode);
                                    });
                            }
                        })(wallCommentData.cid, wallCommentNode);
                        actionNode.textContent = getLocalizedText('delete');
                        wallCommentNode.querySelector('.actions').appendChild(
                        actionNode);
                        postNode.insertBefore(wallCommentNode, actionsWrapNode);
                    }
                    //if ((!userChanged)&&(!self.firstRun)&&(VkApiParams.userId != wallCommentData.uid)){
                    //self.notifyUser('wall');
                    //}
                }
                if (item.online) {
                    postNode.className = 'update online';
                } else {
                    postNode.className = 'update offline';
                }
            }
        },
        processMessages: function(userChanged) {
            var self = this;
            //remove notifies if user already has saw new messages in browser
            self.updatesCount['messages'] = Math.max(0, self.updatesCount['messages'] + Math.min(0, self.data.other.unreadMessages - parseInt(Storage.getValue('other.unreadMessages'))));
            self.displayUpdatesInfo();
            Storage.setValue('other.unreadMessages', self.data.other.unreadMessages);
            if ((self.data.messages.length > 1) && ((self.firstRun) || (userChanged) || ( parseInt( Storage.getValue('messagesChangetime')) != self.data.messages[ 1 ].date ))) {
                while (self.tabs.messages.hasChildNodes()) {
                    self.tabs.messages.removeChild(self.tabs.messages.firstChild);
                }
                var lastInMessageNum = 0;
                var sendersUids = {};
                for (var i = 1, length = self.data.messages.length; i < length; i++) {
                    sendersUids[self.data.messages[i]['uid']] = '';
                    if ( ( ! self.data.messages[i].out) && ( (!lastInMessageNum) || (self.data.messages[i].date > self.data.messages[lastInMessageNum].date )) ) {
                        lastInMessageNum = i;
                    }

                    var item = self.data.messages[i];
                    var profile = self.data.profiles[item.uid] || {
                        uid: item.uid,
                        first_name: 'undefined',
                        last_name: 'undefined',
                        photo: 'undefined'
                    };

                    var className = '';

                    if (item.out) {
                        className += ' out';
                    }

                    //if (typeof self.data.friends[profile.uid] != 'undefined') {
                    if (typeof self.data.onlineFriendsIds[profile.uid] != 'undefined') {
                        className += ' online';
                    } else {
                        className += ' offline';
                    }
                    //}


                    var unreadMsgsHtml = '';
                    var unreadMids = '';
                    if (Storage.getPref('messagesAsDialogs')) {
                        for (var ii = 1; ii < self.data.messagesHistory[item.uid].length; ii++) {
                            var historyMsgData = self.data.messagesHistory[item.uid][ii];
                            if ( ((historyMsgData.read_state == 1 ) || (historyMsgData.from_id == VkApiParams.userId) ) ) {
                                break;
                            }
                            var attachmentHtml = self.getAttachmentsHtml(historyMsgData);
                            unreadMsgsHtml = '<br/>' + unreadMsgsHtml;
                            if (attachmentHtml) {
                                unreadMsgsHtml =  self.getAttachmentsHtml(historyMsgData) + unreadMsgsHtml;
                            }

                            if (historyMsgData.body) {
                                unreadMsgsHtml = '<span>' + linkify(historyMsgData.body) + '</span> <br/>' + unreadMsgsHtml;
                            }

                            unreadMids += ','+historyMsgData.mid;
                        }
                        unreadMsgsHtml = unreadMsgsHtml.substr(0, unreadMsgsHtml.length - 5);
                        //last message from history is preferable, as it's uncut
                        //due to VK bug
                        var msgTxt = self.data.messagesHistory[item.uid][0]?self.data.messagesHistory[item.uid][1].body:item.body;
                        unreadMsgsHtml = (
                            item.out ?
                            '<img class="inline-author" src="' + correctVkBase(self.data.profiles[VkApiParams.userId].photo) + '"/>' :
                            ''
                        ) + (
                            unreadMsgsHtml || (
                                ( msgTxt ? '<span>' + linkify(msgTxt) + '</span><br/>' : '' ) + self.getAttachmentsHtml(item))
                        );
                    } else {
                        unreadMsgsHtml = ( item.body ? '<span>' + linkify(item.body) + '</span><br/>' : '' ) + self.getAttachmentsHtml(item);
                    }

                    unreadMids = unreadMids.substr(1);

                    var buttons = {};
                    /*
                    * adds button to answer with private message
                    */
                    buttons[getLocalizedText('message')] = (function(uid, item, title, unreadMids) {
                        return function() {
                            var selfActionNode = this;
                            vkfox.showSendBox(
                                function(message) {
                                    if (item.read_state == 0) {
                                        self.markMessageAsRead(
                                            unreadMids || item.mid, function() {
                                                try {
                                                    selfActionNode.parentNode.querySelector('.mark-as-read').onclick();
                                                } catch(e) {
                                                    if (Storage.getPref('logErrors')) {
                                                        log('error.selfActionNode; e : ' + e);
                                                        debug(selfActionNode);
                                                    }
                                                }
                                            });
                                    }
                                    self.sendMessage(uid, message, function(data) {
                                        self.hideSendBox();
                                    });
                                },
                                title
                            )
                        }
                    })(profile.uid, item, getLocalizedText('message') + ' : ' + profile.first_name + ' ' + profile.last_name, unreadMids);

                    /*
                    * adds button to open message in browser
                    */
                    buttons[getLocalizedText('open')] = (function(uid) {
                        return function() {
                            openUrl(addBaseUrl('im?sel=' + uid));
                        }
                    })(profile.uid);

                    /*
                    * adds button to delete message,
                    */
                    buttons[getLocalizedText('delete')] = (function(mid) {
                        return function() {
                            var selfActionNode = this;
                            self.deleteMessage(
                                mid, function() {
                                    removeNodes(selfActionNode.parentNode.parentNode.parentNode.parentNode);
                                });
                        }
                    })(item.mid);
                    /*
                    * adds button to show history
                    */
                    buttons[getLocalizedText('history')] = {
                        className : ' history',
                        onclick : (function(uid) {
                            return function() {
                                var selfActionNode = this;
                                var selfMessageNode = selfActionNode.parentNode.parentNode.parentNode.parentNode;
                                if (selfActionNode.textContent == getLocalizedText('history')) {
                                    var historyData = self.data.messagesHistory[uid];
                                    if (historyData[0]) {
                                        selfMessageNode.querySelector('.action.history').textContent = getLocalizedText('hide');
                                    }
                                    for (var i = 1; i < historyData.length; i++) {
                                        var historyMessageData = historyData[i];
                                        var profile = self.data.profiles[historyMessageData.from_id] || self.data.friends[historyMessageData.from_id] || {
                                            uid: historyMessageData.from_id,
                                            first_name: 'undefined',
                                            last_name: 'undefined',
                                            photo: 'undefined'
                                        };

                                        var buttons = [];
                                        var className = ' wall-comment';
                                        if (historyMessageData.read_state == 0 ) {
                                            //className += ' unread';
                                            if ((historyMessageData.from_id != VkApiParams.userId)) {
                                                buttons[ getLocalizedText('markAsRead') ] = {
                                                    className : ' mark-as-read',
                                                    onclick : (function(mid) {
                                                        return function() {
                                                            var selfActionNode = this;
                                                            self.markMessageAsRead(
                                                                mid, function() {
                                                                    try {
                                                                        selfActionNode.parentNode.parentNode.parentNode.parentNode.className = 'update wall-comment no-actions';
                                                                    } catch(e) {
                                                                        if (Storage.getPref('logErrors')) {
                                                                            log('error.selfActionNode; e : ' + e);
                                                                            debug(selfActionNode);
                                                                        }
                                                                    }
                                                                    removeNodes(selfActionNode);
                                                                });
                                                        }
                                                    })(historyMessageData.mid)
                                                }
                                            } else {
                                                className += ' no-actions';
                                            }
                                        } else {
                                            className += ' no-actions';
                                        }


                                        var historyNode= (new UpdateItem(
                                            {
                                                className : className,
                                                caption : profile.first_name + ' ' + profile.last_name,
                                                link : '/id' + profile.uid,
                                                img_src : correctVkBase(profile.photo),
                                                addChilds : {
                                                    '.text' : linkify(historyMessageData.body),
                                                    '.media' : self.getAttachmentsHtml(historyMessageData)
                                                },
                                                buttons : buttons
                                            }
                                        )).node;

                                        selfMessageNode.appendChild(historyNode);
                                    }
                                    historyNode.className += ' last';
                                } else {
                                    selfMessageNode.querySelector('.action.history').textContent = getLocalizedText('history');
                                    removeNodes(selfMessageNode.querySelectorAll('.update.wall-comment'));
                                }
                            }
                        })(profile.uid)
                    }

                    /*
                    * adds button to mark message,
                    * as read if it's not already marked
                    */
                    if ((item.read_state == 0) && (!item.out)) {
                        buttons[getLocalizedText('markAsRead')] = {
                            className : ' mark-as-read',
                            onclick : (function(mid) {
                                return function() {
                                    var selfActionNode = this;
                                    self.markMessageAsRead(
                                        mid, function() {
                                            try {
                                                selfActionNode.parentNode.parentNode.parentNode.className = 'actions-wrap';
                                                selfActionNode.parentNode.parentNode.parentNode.parentNode.classList.remove('unread');
                                            } catch(e) {
                                                if (Storage.getPref('logErrors')) {
                                                    log('error.selfActionNode; e : ' + e);
                                                    debug(selfActionNode);
                                                }
                                            }
                                            removeNodes(selfActionNode);
                                        });
                                }
                            })(unreadMids || item.mid)
                        }
                    }

                    var messageNode =  (new UpdateItem(
                        {
                            className : className,
                            caption : profile.first_name + ' ' + profile.last_name,
                            link : '/id'+profile.uid,
                            img_src : correctVkBase(profile.photo),
                            addChilds : {
                                '.media' : unreadMsgsHtml,
                                '.title' : item.title
                            },
                            buttons : buttons
                        }
                    )).node;


                    if ((item.read_state == 0) && (!item.out)) {
                        messageNode.querySelector('.actions-wrap').className += ' two-rows';
                    }
                    messageNode.setAttribute('data-uid', profile.uid);
                    self.tabs.messages.appendChild(messageNode);
                }

                if (
                    (!userChanged) &&
                    ( parseInt(Storage.getValue('messagesChangetime')) < self.data.messages[lastInMessageNum].date ) && 
                    (self.data.messages[lastInMessageNum].read_state == 0) &&
                    (!self.data.messages[1].out)
                ) {
                    self.notifyUser('messages', self.tabs.messages.firstElementChild);
                }
                Storage.setValue('messagesChangetime', self.data.messages[1].date);
                for (var uid in self.data.messagesHistory) {
                    if ( !(uid in sendersUids) ) {
                        //log('success' + self.data.messagesHistory[uid]);
                        delete  self.data.messagesHistory[uid];
                    }
                }
            }
            for (var i = 1, length = self.data.messages.length; i < length; i++) {
                if (typeof self.tabs.messages.childNodes[i - 1] != 'undefined') {
                    if (typeof self.data.friends[self.tabs.messages.childNodes[i - 1].getAttribute('data-uid')] != 'undefined') {
                        if (typeof self.data.onlineFriendsIds[self.tabs.messages.childNodes[i - 1].getAttribute('data-uid')] != 'undefined') {
                            self.tabs.messages.childNodes[i - 1].classList.add('online');
                            self.tabs.messages.childNodes[i - 1].classList.remove('offline');
                        } else {
                            self.tabs.messages.childNodes[i - 1].classList.add('offline');
                            self.tabs.messages.childNodes[i - 1].classList.remove('online');
                        }
                    }
                    if (self.data.messages[i].read_state == 0){
                        self.tabs.messages.childNodes[i - 1].classList.add('unread');
                    } else {
                        self.tabs.messages.childNodes[i - 1].classList.remove('unread');
                    }
                }
            }
        },
        processComments: function(userChanged) {
            var self = this;
            var updateNodeSample = self.vkfoxSamplesNode.querySelector('.update');
            var actionNodeSample = self.vkfoxSamplesNode.querySelector('.action');
            var notify = false;
            if (self.data.comments) {
                var responseNode = NodeFromHtml(self.data.comments);
                self.data.comments = '';
                var feedRowNodes = responseNode.querySelectorAll('.feed_row');
                if (feedRowNodes.length) {
                    var otherFirstChildNode = self.otherContainerNode.firstChild;
                    var replyNodeList = feedRowNodes[0].querySelectorAll(".reply");
                    if ((replyNodeList.length) && (lastCommentAuthorId = replyNodeList[replyNodeList.length - 1].querySelector('.reply_image img').src.match(/u(\d+)/))) {
                        var lastCommentAuthorId = lastCommentAuthorId[1];
                    } else {
                        var lastCommentAuthorId = 'unknown';
                    }
                    for (var i = 0; i < feedRowNodes.length; i++) {
                        var idNode = feedRowNodes[i].querySelector('[id]');
                        var updateNode;
                        if (! ((idNode) && (updateNode = self.tabs.other.querySelector('.update.' + idNode.id)))) {
                            updateNode = updateNodeSample.cloneNode(true);

                            var replyIconNode = feedRowNodes[i].querySelector('.post_image');
                            var updateAuthorNode = feedRowNodes[i].querySelector('.author');
                            var updateMediaNode = feedRowNodes[i].querySelector('.post_media, .media_desc');
                            var updateTextNode = feedRowNodes[i].querySelector('.text');
                            if (updateTextNode) {
                                var showWholeNode = updateTextNode.querySelector('[onclick*=hide]');
                                if (showWholeNode) {
                                    showWholeNode.removeAttribute('href');
                                    showWholeNode.addEventListener(
                                        'click',
                                        function() {
                                            log(1);
                                            show(this.nextSibling);
                                            removeNodes([this, this.previousSibling]);
                                        },
                                        true
                                    );
                                }
                            }

                            var buttons = {};
                            var unsubscribeParams = feedRowNodes[i].querySelector("[id^=delete_post]").getAttribute('onclick').match(/\((.*)\)/)[1].replace(/['\s]/g, '').split(',');
                            buttons[ getLocalizedText('unsubscribe') ] = (function(post_raw, hash, updateNode) {
                                return function() {
                                    self.unsubscribeFromComment(
                                    post_raw, hash, this);
                                }
                            })(unsubscribeParams[0], unsubscribeParams[1]);
                            buttons[ getLocalizedText('comment') ] = (function(reply_to, reply_to_msg, start_id, post_hash, title) {
                                return function() {
                                    vkfox.showSendBox(

                                    function(message) {
                                        self.sendReply(
                                        message, reply_to, reply_to_msg, start_id, post_hash, function(data) {
                                            self.hideSendBox();
                                        });
                                    },
                                    title)
                                }
                            })(
                                unsubscribeParams[0], '', feedRowNodes[i].querySelector('#start_reply' + unsubscribeParams[0]).value, feedRowNodes[i].querySelector('#post_hash' + unsubscribeParams[0]).value,  getLocalizedText('comment') + ' : ' + (updateAuthorNode?updateAuthorNode.textContent:'')
                            );

                            var matches = idNode.id.match(/post(-?\d+)_\D*(\d+)/i);

                            if (idNode.id.indexOf('topic') != -1) {
                                var url = 'topic'+matches[1]+'_'+matches[2]+'?offset=last&scroll=1';
                            } else if (idNode.id.indexOf('note') != -1) {
                                var url = 'note'+matches[1]+'_'+matches[2]+'?offset=last&scroll=1';
                            } else {
                                var url = 'wall'+matches[1]+'_'+matches[2];
                            }

                            buttons[ getLocalizedText('open') ] = (function(url) {
                                return function() {
                                    openUrl(url);
                                }
                            })(addBaseUrl(url));

                            var updateNode = (new UpdateItem(
                                {
                                    className : ' ' + idNode.id + ' comments',
                                    addChilds : {
                                        '.image-wrap' : replyIconNode && cleanFormatting(replyIconNode),
                                        '.caption' : updateAuthorNode && cleanFormatting(updateAuthorNode),
                                        '.media' : updateMediaNode && cleanFormatting(updateMediaNode),
                                        '.text' : updateTextNode && cleanFormatting(updateTextNode)
                                    },
                                    buttons : buttons,
                                    showMoreButton : true
                                }
                                )).node;
                        }

                        var actionsWrapNodeList = updateNode.querySelectorAll('.actions-wrap');
                        var actionsWrapNode = actionsWrapNodeList[actionsWrapNodeList.length - 1];
                        actionsWrapNodeList = null;

                        replyNodeList = feedRowNodes[i].querySelectorAll(".reply");
                        for (var j = 0; j < replyNodeList.length; j++) {
                            var replyNode = updateNodeSample.cloneNode(true);
                            replyNode.className += ' wall-comment no-actions';

                            var replyIconNode = replyNodeList[j].querySelector('.reply_image');
                            if (replyIconNode) {
                                replyNode.querySelector('.image-wrap').appendChild(
                                cleanFormatting(replyIconNode));
                            }
                            replyIconNode = null;
                            var replyAuthorNode = replyNodeList[j].querySelector('.author')
                            if (replyAuthorNode) {
                                replyNode.querySelector('.caption').appendChild(
                                cleanFormatting(replyAuthorNode));
                            }
                            replyAuthorNode = null;
                            var replyTextNode = replyNodeList[j].querySelector('.reply_text');
                            
                            if (replyTextNode) {
                                var showWholeNode = replyTextNode.querySelector('[onclick*=hide]');
                                if (showWholeNode) {
                                    showWholeNode.removeAttribute('href');
                                    showWholeNode.addEventListener(
                                        'click',
                                        function() {
                                            log(1);
                                            show(this.nextSibling);
                                            removeNodes([this, this.previousSibling]);
                                        },
                                        true
                                    );
                                }

                                replyNode.querySelector('.text').appendChild(
                                cleanFormatting(replyTextNode));
                            }

                            replyTextNode = null;
                            updateNode.insertBefore(replyNode, actionsWrapNode);
                        }
                        if (i == 0) {
                            var notificationNode = replyNode;
                        }
                        actionsWrapNode = null;
                        if (otherFirstChildNode) {
                            self.otherContainerNode.insertBefore(
                            updateNode, otherFirstChildNode);
                        } else {
                            self.otherContainerNode.appendChild(
                            updateNode);
                        }
                        notify = true;
                    }
                    var lastCommentReplyText = notificationNode.textContent;
                    if ((!userChanged) && (lastCommentAuthorId != VkApiParams.userId) && (Storage.getValue('lastCommentReplyText') != lastCommentReplyText) && notify) {
                        self.notifyUser('other', notificationNode, getLocalizedText('comments'));
                        self.tabs.other.querySelector('.filter.comments .radiobutton').onclick();
                        Storage.setValue('lastCommentReplyText', lastCommentReplyText);
                    }
                }
            }
        },
        processOther: function(userChanged) {
            var self = this;
            var updateNodeSample = document.querySelector('.samples .update');
            var actionNodeSample = document.querySelector('.samples .action');
            var typeNameToUrl = {
                friends: '/friends?section=requests',
                groups: '/al_groups.php?act=get_list&al=1&al_ad=1&mid='+VkApiParams.userId+'&tab=inv',
                videos: '/video?section=tagged',
                photos: '/photos.php?act=added',
                events: '/events.php?tab=invitations',
            }
            for (var name in typeNameToUrl) {
                var diff = self.data.other[name] - parseInt(Storage.getValue('other.' + name));
                //if (self.firstRun){
                    //diff = 4;
                //}
                if ((diff > 0) && (Storage.getPref('notify.' + name))) {
                    DataLoader.request('http://' + Storage.getPref('server') + typeNameToUrl[name], null, (function() {
                        var newItemsCount = diff;
                        var typeName = name;
                        var firstRun = self.firstRun;
                        //var userChanged = self.userChanged;
                        return function(data) {
                            var responseNode = NodeFromHtml(data);
                            var otherFirstChildNode = self.otherContainerNode.firstChild;
                            switch (typeName) {
                            case 'friends':
                                var sourceNodes = responseNode.querySelectorAll('#list_content .request');
                                Storage.setValue('other.' + typeName, self.data.other[typeName]);
                                for (var i = 0; i < Math.min(sourceNodes.length, OTHER_ITEM_COUNT, newItemsCount); i++) {
                                    var item = sourceNodes[i];
                                    removeNodes(item.querySelectorAll('.online, .controls, .common_friends_label'));
                                    var updateNode = updateNodeSample.cloneNode(true);
                                    updateNode.className += ' other';
                                    updateNode.querySelector('.image-wrap').appendChild(
                                    cleanFormatting(item.querySelector('.img')));
                                    var captionNode = updateNode.querySelector('.caption');
                                    captionNode.textContent = getLocalizedText('friendRequest');
                                    captionNode.onclick = (function(url) {
                                        return function() {
                                            openUrl(addBaseUrl(url));
                                        };
                                    })(typeNameToUrl[typeName]);
                                    updateNode.querySelector('.body').appendChild(
                                    cleanFormatting(item.querySelector('.info')));
                                }
                                break;
                            case 'groups':
                                //TODO
                                Storage.setValue('other.' + typeName, self.data.other[typeName]);
                                var updateNode = (new UpdateItem(
                                {
                                    className : ' other',
                                    caption : getLocalizedText('groupInvite'),
                                    link : '/groups?tab=inv',
                                    img_src : 'chrome://vkfox/content/images/image_group.png',
                                }
                                )).node;


                                break;
                                var sourceNodes = responseNode.querySelectorAll('.group_list_row');
                                removeNodes(responseNode.querySelectorAll('.group_row_buttons'));
                                for (var i = 0; i < Math.min(sourceNodes.length, OTHER_ITEM_COUNT, newItemsCount); i++) {
                                    var item = sourceNodes[i];
                                    var updateNode = updateNodeSample.cloneNode(true);
                                    updateNode.className += ' other';
                                    updateNode.querySelector('.image-wrap').appendChild(
                                    cleanFormatting(item.querySelector('.group_row_photo')));
                                    updateNode.querySelector('.body').appendChild(
                                    cleanFormatting(item.querySelector('.group_row_info')));
                                    var captionNode = updateNode.querySelector('.caption');
                                    captionNode.textContent = getLocalizedText('groupInvite');
                                    captionNode.onclick = (function(url) {
                                        return function() {
                                            openUrl(addBaseUrl(url));
                                        };
                                    })(typeNameToUrl[typeName]);
                                    if (item.querySelector('div .memLink')) {
                                        updateNode.querySelector('.body').appendChild(
                                        cleanFormatting(item.querySelector('div .memLink').parentNode));
                                    }
                                }
                                break;
                            case 'videos':
                                var sourceNodes = responseNode.querySelectorAll('.video_row');
                                //removeNodes(responseNode.querySelectorAll('[id^=videoInfo] .video_created'));
                                //removeNodes(responseNode.querySelectorAll('[class^=video_duration]'));
                                Storage.setValue('other.' + typeName, self.data.other[typeName]);
                                //for (var i = sourceNodes.length - 1; i >= Math.max(0, sourceNodes.length - OTHER_ITEM_COUNT, sourceNodes.length - newItemsCount); i--) {
                                for (var i = 0; i < Math.min(sourceNodes.length, OTHER_ITEM_COUNT, newItemsCount); i++) {
                                    var item = sourceNodes[i];
                                    var updateNode = updateNodeSample.cloneNode(true);
                                    updateNode.className += ' other';
                                    updateNode.querySelector('.image-wrap').appendChild(
                                    cleanFormatting(item.querySelector('.video_thumb')));
                                    var captionNode = updateNode.querySelector('.caption');
                                    captionNode.textContent = getLocalizedText('videoTag');
                                    captionNode.onclick = (function(url) {
                                        return function() {
                                            openUrl(addBaseUrl(url));
                                        };
                                    })(typeNameToUrl[typeName]);
                                    updateNode.querySelector('.body').appendChild(
                                    cleanFormatting(item.querySelector('.video_info')));
                                }
                                break;
                            case 'photos':
                                var sourceNodes = responseNode.querySelectorAll('.photos_tag_page #photos_container a');
                                Storage.setValue('other.' + typeName, self.data.other[typeName]);
                                for (var i = sourceNodes.length - 1; i >= Math.max(0, sourceNodes.length - OTHER_ITEM_COUNT, sourceNodes.length - newItemsCount); i--) {
                                    var item = sourceNodes[i];
                                    var updateNode = updateNodeSample.cloneNode(true);
                                    updateNode.className += ' other';
                                    updateNode.querySelector('.image-wrap').appendChild(
                                    cleanFormatting(item));
                                    var captionNode = updateNode.querySelector('.caption');
                                    captionNode.textContent = getLocalizedText('photoTag');
                                    captionNode.onclick = (function(url) {
                                        return function() {
                                            openUrl(addBaseUrl(url));
                                        };
                                    })(typeNameToUrl[typeName]);
                                }
                                break;
                            case 'events':
                                var sourceNodes = responseNode.querySelectorAll('#events_list_tab_invitations [id^=event_row]');
                                removeNodes(responseNode.querySelectorAll('.change_status, .actions'));
                                Storage.setValue('other.' + typeName, self.data.other[typeName]);
                                for (var i = 0; i < Math.min(sourceNodes.length, OTHER_ITEM_COUNT, newItemsCount); i++) {
                                    //for (var i=Math.min(sourceNodes.length, OTHER_ITEM_COUNT, newItemsCount)-1;i>=0;i--){
                                    var item = sourceNodes[i];
                                    var updateNode = updateNodeSample.cloneNode(true);
                                    updateNode.className += ' other';
                                    updateNode.querySelector('.image-wrap').appendChild(
                                    cleanFormatting(item.querySelector('.photo')));
                                    var captionNode = updateNode.querySelector('.caption');
                                    captionNode.textContent = getLocalizedText('eventInvite');
                                    captionNode.onclick = (function(url) {
                                        return function() {
                                            openUrl(addBaseUrl(url));
                                        };
                                    })(typeNameToUrl[typeName]);
                                    updateNode.querySelector('.body').appendChild(
                                    cleanFormatting(item.querySelector('.info')));
                                }
                                break;
                            }
                            if (!userChanged) {
                              if (updateNode) {
                                var newNodeText = updateNode.textContent;
                                var updateOtherNodeList = self.otherContainerNode.querySelectorAll('.other');
                                var unique = true;
                                for (var i = 0, len = updateOtherNodeList.length; i < len; i++) {
                                  if (updateOtherNodeList[i].textContent == newNodeText) {
                                    unique = false;
                                    break;
                                  }
                                }
                                if (unique) {
                                  if (otherFirstChildNode) {
                                    self.otherContainerNode.insertBefore(
                                    updateNode, otherFirstChildNode);
                                  } else {
                                    self.otherContainerNode.appendChild(
                                    updateNode);
                                  }
                                  self.notifyUser('other', updateNode);
                                  self.tabs.other.querySelector('.filter.other .radiobutton').onclick();
                                }
                              }
                            }
                        }
                    })(), true);
                } else {
                    Storage.setValue('other.' + name, self.data.other[name]);
                }
            }
        },
          processFriends: function() {
            //		var start = new Date().getTime();
            var self = this;
            var updateNodeSample = document.querySelector('.samples .update');
            var actionNodeSample = document.querySelector('.samples .action');
            var usersToWatch = (Storage.getUserPref('usersToWatch') + '').split(',');
            for (var i = 1; i < usersToWatch.length; i++) {
                var friendsNode = self.tabs.friends.querySelector('.update.uid-' + usersToWatch[i]);
                if (friendsNode) {
                    if (/online/.test(friendsNode.className) ? typeof self.data.onlineFriendsIds[usersToWatch[i]] == 'undefined': typeof self.data.onlineFriendsIds[usersToWatch[i]] != 'undefined') {
                        var updateNode;
                        if (! (updateNode = self.tabs.other.querySelector('.id' + usersToWatch[i]))) {
                            var updateNode = updateNodeSample.cloneNode(true);
                            updateNode.className += ' other login-status id' + usersToWatch[i];
                            var imgNode = updateNode.querySelector('.image-wrap img');
                            imgNode.src = friendsNode.querySelector('.image-wrap img').src;
                            imgNode.onclick = (function(url) {
                                return function() {
                                    openUrl(addBaseUrl(url));
                                };
                            })('/id' + usersToWatch[i]);
                            /*add button to answer via wall post*/
                            var actionNode = actionNodeSample.cloneNode(true);
                            actionNode.textContent = getLocalizedText('wall');
                            actionNode.onclick = (function(owner_id, title) {
                                return function() {
                                    vkfox.showSendBox(

                                        function(message) {
                                            self.sendWallPost(owner_id, message, function(data) {
                                                self.hideSendBox()
                                            });
                                        },
                                    title)
                                }
                            })(usersToWatch[i], actionNode.textContent + ' : ' + friendsNode.querySelector('.caption').textContent);
                            updateNode.querySelector('.actions').appendChild(
                            actionNode);
                            /*
                            * adds button to answer with private message
                            */
                            var actionNode = actionNodeSample.cloneNode(true);
                            actionNode.textContent = getLocalizedText('message');
                            actionNode.onclick = (function(uid, title) {
                                return function() {
                                    vkfox.showSendBox(

                                        function(message) {
                                            self.sendMessage(uid, message, function(data) {
                                                self.hideSendBox();
                                            });
                                        },
                                    title)
                                }
                            })(usersToWatch[i], actionNode.textContent + ' : ' + friendsNode.querySelector('.caption').textContent);
                            updateNode.querySelector('.actions').appendChild(
                            actionNode);

                        }
                        var textNode = updateNode.querySelector('.text');
                        textNode.textContent = '';
                        var captionNode = updateNode.querySelector('.caption');
                        if (typeof self.data.onlineFriendsIds[usersToWatch[i]] != 'undefined') {
                            captionNode.textContent = getLocalizedText('friendCameOnline');
                            updateNode.className = updateNode.className.replace(' offline', '') + ' online';
                        } else {
                            captionNode.textContent = getLocalizedText('friendWentOffline');
                            updateNode.className = updateNode.className.replace(' online', '') + ' offline';
                        }
                        var dateO = new Date();
                        var hh = dateO.getHours() + '';
                        var mm = dateO.getMinutes() + '';
                        if (hh.length == 1) {
                            hh = '0' + hh;
                        }
                        if (mm.length == 1) {
                            mm = '0' + mm;
                        }
                        textNode.appendChild(
                            cleanFormatting(
                                NodeFromHtml('<div><a href="/id' + usersToWatch[i] + '">' + friendsNode.querySelector('.caption').textContent + '</a><span class="time">' + hh + ':' + mm + '</span></div>')));
                                var otherFirstChildNode = self.otherContainerNode.firstChild;
                                if (otherFirstChildNode) {
                                    self.otherContainerNode.insertBefore(
                                    updateNode, otherFirstChildNode);
                                } else {
                                    self.otherContainerNode.appendChild(
                                    updateNode);
                                }
                                self.notifyUser('friends', updateNode);
                                self.tabs.other.querySelector('.filter.other .radiobutton').onclick();
                    }
                }
            }
            if (self.userChanged || self.firstRun || (!self.friendsContainerNode.childElementCount)) {
                while (self.friendsContainerNode.hasChildNodes()) {
                    self.friendsContainerNode.removeChild(self.friendsContainerNode.firstChild);
                }
                var friendListsNode = self.tabs.friends.querySelector('.friend-lists');
                while (friendListsNode.hasChildNodes()) {
                    friendListsNode.removeChild(friendListsNode.firstChild);
                }
                if (count(self.data.friendLists)){
                    show(self.tabs.friends.querySelector('.drop-down-button'));
                    for (var lid in self.data.friendLists) {
                        friendListsNode.appendChild(NodeFromHtml('@' + self.data.friendLists[lid]));
                    }
                } else {
                    hide(self.tabs.friends.querySelector('.drop-down-button'));
                }
                var sortedFriendIds = [];
                for (var uid in self.data.friends) {
                    sortedFriendIds.push(uid);
                }
                sortedFriendIds.sort(
                    function(a, b) {
                        if ((self.data.friends[a].first_name + ' ' + self.data.friends[a].last_name).toLowerCase() > (self.data.friends[b].first_name + ' ' + self.data.friends[b].last_name).toLowerCase()) {
                            return 1;
                        } else {
                            return -1; 
                        }
                    }
                );

                for ( var k=0; k < sortedFriendIds.length;k++ ){
                    var uid = sortedFriendIds[k];
                    var item = self.data.friends[uid];
                    var friendsNode = self.tabs.friends.querySelector('.update.uid-' + uid);
                    if (!friendsNode) {
                        friendsNode = updateNodeSample.cloneNode(true);
                        friendsNode.className += ' uid-' + uid;
                        var nameNode = friendsNode.querySelector('.caption');
                        var mediaNode = friendsNode.querySelector('.media');
                        nameNode.textContent = item.first_name + ' ' + item.last_name;
                        nameNode.onclick = (function(url) {
                            return function() {
                                openUrl(addBaseUrl(url));
                            };
                        })('/id' + uid);
                        var imgNode = friendsNode.querySelector('img');
                        imgNode.setAttribute('src', correctVkBase(item.photo));
                        imgNode.onclick = (function(url) {
                            return function() {
                                openUrl(addBaseUrl(url));
                            };
                        })('/id' + uid);
                        switch (item.sex) {
                            case '1':
                                friendsNode.className += ' female';
                                break;
                            case '2':
                                friendsNode.className += ' male';
                                break;
                        }
                        //adding hidden text for searching by nickname
                        mediaNode.appendChild(
                            NodeFromHtml('<div class="hidden nickname">' + item.nickname + '</div>')
                        );
                        if (typeof item.lists != 'undefined') {
                            for (var i in item.lists) {
                                mediaNode.appendChild(
                                    NodeFromHtml('<div class="friend-list hidden">@' + self.data.friendLists[item.lists[i]] + '</div>')
                                );
                            }
                        }
                        //checkbox for notifying about login/logout
                        var checkboxNode = document.createElementNS("http://www.w3.org/1999/xhtml", 'input');
                            checkboxNode.type = "checkbox";
                            if ((new RegExp(',' + uid + '(,|$)')).test(Storage.getUserPref('usersToWatch'))) {
                                checkboxNode.checked = true;
                            } else {
                                checkboxNode.checked = false;
                            }
                            mediaNode.appendChild(
                            checkboxNode);
                            checkboxNode.onclick = (function(uid, node) {
                                return function() {
                                    if (node.checked) {
                                        //localStorage['usersToWatch'] += ',' + uid;
                                        Storage.setUserPref( 'usersToWatch', Storage.getUserPref('usersToWatch') + ',' + uid);
                                    } else {
                                        Storage.setUserPref('usersToWatch', (Storage.getUserPref('usersToWatch') + '').replace(',' + uid, ''));
                                    }
                                }
                            })(uid, checkboxNode);
                            styleCheckbox(checkboxNode, checkboxNode.checked);
                            mediaNode.appendChild(
                                NodeFromHtml('<span>' + getLocalizedText('notify_about_user_login_logout') + '</span>'));
                                /*add button to answer via wall post*/
                                var actionNode = actionNodeSample.cloneNode(true);
                                actionNode.textContent = getLocalizedText('wall');
                                actionNode.onclick = (function(owner_id, title) {
                                    return function() {
                                        vkfox.showSendBox(

                                            function(message) {
                                                self.sendWallPost(owner_id, message, function(data) {
                                                    self.hideSendBox()
                                                });
                                            },
                                        title)
                                    }
                                })(uid, actionNode.textContent + ' : ' + friendsNode.querySelector('.caption').textContent);
                                friendsNode.querySelector('.actions').appendChild(
                                actionNode);
                                /*
                                * adds button to answer with private message
                                */
                                var actionNode = actionNodeSample.cloneNode(true);
                                actionNode.textContent = getLocalizedText('message');
                                actionNode.onclick = (function(uid, title) {
                                    return function() {
                                        vkfox.showSendBox(

                                            function(message) {
                                                self.sendMessage(uid, message, function(data) {
                                                    self.hideSendBox();
                                                });
                                            },
                                        title)
                                    }
                                })(uid, actionNode.textContent + ' : ' + friendsNode.querySelector('.caption').textContent);
                                friendsNode.querySelector('.actions').appendChild(
                                actionNode);
                                /*
                                * adds button to open photos in browser
                                */
                                var actionNode = actionNodeSample.cloneNode(true);
                                actionNode.onclick = (function(uid) {
                                    return function() {
                                        openUrl(addBaseUrl('http://' + Storage.getPref('server') + '/photos' + uid));
                                    }
                                })(uid);
                                actionNode.textContent = getLocalizedText('photo');
                                friendsNode.querySelector('.actions').appendChild(
                                actionNode);
                                self.friendsContainerNode.appendChild(friendsNode);
                                /*
                                * adds button to show history
                                */
                                var actionNode = actionNodeSample.cloneNode(true);
                                actionNode.onclick = (function(mid, selfMessageNode, friendData) {
                                    return function() {
                                        self.getMessageHistory(
                                            mid, function(data) {
                                                var selfActionNode = selfMessageNode.querySelector('.action.history');
                                                if (selfActionNode.textContent == getLocalizedText('history')) {
                                                    var historyData = parseJson(data).response;
                                                    if (historyData[0]) {
                                                        selfMessageNode.querySelector('.action.history').textContent = getLocalizedText('hide');
                                                    }
                                                    for (var i = 1; i < historyData.length; i++) {
                                                        var historyMessageData = historyData[i];
                                                        var profile = self.data.profiles[historyMessageData.from_id] || self.data.friends[historyMessageData.from_id] || {
                                                            uid: historyMessageData.from_id,
                                                            first_name: 'undefined',
                                                            last_name: 'undefined',
                                                            photo: 'undefined'
                                                        };

                                                        var buttons = [];
                                                        if ((historyMessageData.read_state == 0 ) && (historyMessageData.from_id != VkApiParams.userId)) {
                                                            var className = ' wall-comment';
                                                            buttons[ getLocalizedText('markAsRead') ] = {
                                                                className : ' mark-as-read',
                                                                onclick : (function(mid) {
                                                                    return function() {
                                                                        var selfActionNode = this;
                                                                        self.markMessageAsRead(
                                                                            mid, function() {
                                                                                try {
                                                                                    selfActionNode.parentNode.parentNode.parentNode.parentNode.className = 'update wall-comment no-actions';
                                                                                } catch(e) {
                                                                                    if (Storage.getPref('logErrors')) {
                                                                                        log('error.selfActionNode; e : ' + e);
                                                                                        debug(selfActionNode);
                                                                                    }
                                                                                }
                                                                                removeNodes(selfActionNode);
                                                                            });
                                                                    }
                                                                })(historyMessageData.mid)
                                                            }
                                                        } else {
                                                            var className = ' wall-comment no-actions';
                                                        }


                                                        var historyNode= (new UpdateItem(
                                                            {
                                                                className : className,
                                                                caption : profile.first_name + ' ' + profile.last_name,
                                                                link : '/id' + profile.uid,
                                                                img_src : correctVkBase(profile.photo),
                                                                addChilds : {
                                                                    '.text' : linkify(historyMessageData.body),
                                                                    '.media' : self.getAttachmentsHtml(historyMessageData)
                                                                },
                                                                buttons : buttons
                                                            }
                                                        )).node;

                                                        selfMessageNode.appendChild(historyNode);
                                                    }
                                                    if (historyNode) {
                                                        historyNode.className += ' last';
                                                    }
                                                } else {
                                                    selfMessageNode.querySelector('.action.history').textContent = getLocalizedText('history');
                                                    removeNodes(selfMessageNode.querySelectorAll('.update.wall-comment'));
                                                }
                                            });
                                    }
                                })(uid, friendsNode, item);

                                actionNode.textContent = getLocalizedText('history');
                                actionNode.className += ' history';
                                friendsNode.querySelector('.actions').appendChild(
                                actionNode);

                    }
                    if (item.online) {
                        friendsNode.className = friendsNode.className.replace(/(\s?online)|(\s?offline)/, '') + ' online';
                        self.onlineFriendsNL[friendsNode.className] = friendsNode;
                    } else {
                        friendsNode.className = friendsNode.className.replace(/(\s?online)|(\s?offline)/, '') + ' offline';
                    }
                }
            }
            //runs over all previous online node, adjust their online/offline status
            //and removes from onlineFriendsNL those, which became offline
            //also deletes all processed id's from onlineFriendsIds data
            //then runs over new not yet processed online friends' ids
            var onlineFriendsIds = self.data.onlineFriendsIds;
            for (var i in self.onlineFriendsNL) {
                var friendsNode = self.onlineFriendsNL[i];
                var uid = friendsNode.className.match(/(uid-)(\d+)/)[2];
                if (typeof self.data.onlineFriendsIds[uid] == 'undefined') {
                    friendsNode.className = friendsNode.className.replace(/(\s?online)|(\s?offline)/, '') + ' offline';
                    delete self.onlineFriendsNL[i];
                }
                delete onlineFriendsIds[uid];
            }
            var querySelector = '.uid-';
            for (var uid in onlineFriendsIds) {
                querySelector += uid + ', .uid-';
            }
            if (querySelector.length >= 7) {
                querySelector = querySelector.substr(0, querySelector.length - 7);
            }
            var newOnlineFriendsNL = self.tabs.friends.querySelectorAll(querySelector);
            for (var i = 0; i < newOnlineFriendsNL.length; i++) {
                newOnlineFriendsNL[i].className = newOnlineFriendsNL[i].className.replace(/(\s?online)|(\s?offline)/, '') + ' online';
                self.onlineFriendsNL[newOnlineFriendsNL[i].className] = newOnlineFriendsNL[i];
            }
            //		log(new Date().getTime() - start);
        },
        processData: function() {
            var self = this;
            if ((self.data.other.userId) && (self.data.other.userId != VkApiParams.userId)) {
                self.makeLogin();
                return;
            }
            if (self.userChanged) {
                while (self.otherContainerNode.hasChildNodes()) {
                    self.otherContainerNode.removeChild(self.otherContainerNode.firstChild);
                }
            }
            //main window
            if ((self.userChanged) || (self.firstRun)) {
                try {
                    self.mainboxNode.querySelector('.title').textContent = self.data.profiles[VkApiParams.userId].first_name + ' ' + self.data.profiles[VkApiParams.userId].last_name;
                } catch(e) {
                    //TODO work on this
                    log('error : ' + e);
                }
            }
            setTimeout(
            function() {
                /*
                        * adds private messages
                        */
                if (Storage.getPref('notify.messages')) {
                    self.processMessages(self.userChanged);
                }
                setTimeout(
                function() {
                    /*
                                * adds wall posts
                                */
                    if (Storage.getPref('notify.wall')) {
                        self.processWall(self.userChanged);
                    }
                    setTimeout(
                    function() {
                        /*
                                        * adds comments to "other" tab
                                        */
                        if (Storage.getPref('notify.comments')) {
                            self.processComments(self.userChanged);
                        }
                        setTimeout(
                            function() {
                                /*
                                * adds all other updates to "other" tab
                                */
                                if (Storage.getPref('notify.friendsList')) {
                                    self.processFriends();
                                }
                                setTimeout(
                                    function() {
                                        if (Storage.getPref('notify.news')) {
                                            self.processNewsfeed();
                                        }
                                        /*
                                        * adds all other updates to "other" tab
                                        */
                                        self.processOther(self.userChanged);
                                        self.firstRun = false;
                                        self.userChanged = false;
                                        Event.notify('dataProcessed');
                                    },
                                0);
                            },
                        0);
                    },
                    0);
                },
                0);
            },
            0);
        },
        //get friends data, if all==true then fetches all friends, otherwise only online id's
        getFriendsData: function(force) {
            var self = this;
            //if (!Storage.getPref('notify.friendsList')) {
            //return;
            //}
            if ((self.userChanged || self.firstRun || force) && (Storage.getPref('notify.friendsList'))) {
                DataLoader.addApiQuery({
                    code : 'API.friends.getLists()',
                    handler : function(friendLists){
                        self.data.friendLists = {};
                        for (var i in friendLists) {
                            self.data.friendLists[friendLists[i]['lid']] = friendLists[i]['name'];
                        }
                    }
                });
                DataLoader.addApiQuery({
                    code : 'API.friends.get({ fields : "photo,sex,nickname,lists" })',
                    handler : function(friends){
                        self.onlineFriendsNL = {};
                        self.data.friends = {};
                        //sort my name alphabetically
                        //friends.sort(
                        //function(a, b) {
                        //if ((a.first_name + ' ' + a.last_name) > (b.first_name + ' ' + b.last_name)) {
                        //return true;
                        //} else {
                        //return false;
                        //}
                        //}
                    //);
                        self.data.onlineFriendsIds = {};
                        for (var i in friends) {
                            self.data.friends[friends[i]['uid']] = friends[i];
                            if (friends[i].online) {
                                self.data.onlineFriendsIds[friends[i]['uid']] = true;
                            }
                        }
                    }
                })
            } else {
                DataLoader.addApiQuery({
                    code : 'API.friends.getOnline()',
                    handler : function(onlineFriendsIds){
                        self.data.onlineFriendsIds = {};
                        for (var i in onlineFriendsIds) {
                            self.data.onlineFriendsIds[onlineFriendsIds[i]] = true;
                        }
                    }
                })
            }
        },
        getNewsfeedData: function(handler) {
            var self = this;
            //log('{ news : API.newsfeed.get({start_time: "' + ( parseInt( Storage.getValue('newsfeedLastTimestamp')) ||  'API.getServerTime() - 1 * 24 * 60 * 60 ' ) + '", end_time: API.getServerTime()}), time : API.getServerTime()}');
            DataLoader.addApiQuery({
                code : '{ news : API.newsfeed.get({start_time: "' + ( parseInt( Storage.getValue('newsfeedLastTimestamp')) ||  'API.getServerTime() - 1 * 24 * 60 * 60 ' ) + '", end_time: API.getServerTime(), count : "' + MAX_NEWS_COUNT + '"}), time : API.getServerTime()}',
                handler : function(response){
                    Storage.setValue('newsfeedLastTimestamp',  response.time);
                    self.data.newsfeed = response.news;
                    //debug(response.profiles, true);
                }
            })
        },
        getMediaData: function(handler) {
            var mediaMids = {
                'video': [],
                'audio': []
            }

            var attachments = [];

            if ((self.firstRun) || (self.userChanged) || ( self.data.posts[0] && parseInt(Storage.getValue('wallPostIds') != self.data.posts[1].id) )) {
                for (var i = 1, length = self.data.posts.length; i < length; i++) {
                    var item = self.data.posts[i];
                    if (typeof item.attachments != 'undefined') {
                      for (var j = 0; j < item.attachments.length; j++) {
                        attachments.push(item.attachments[j]);
                        //debug(item.attachments[j]);
                      }
                    }
                }
            }

            if ((self.firstRun) || (self.userChanged) || ( self.data.messages[0] && parseInt( Storage.getValue('messagesChangetime')) < self.data.messages[ 1 ].date )) {
                //distinguishing first element is important for old messages mode, where 10 elements from history
                //may not include all incoming messages
                if (!Storage.getPref('messagesAsDialogs')) {
                    for (var i = 1, length = self.data.messages.length; i < length; i++) {
                        var item = self.data.messages[i];
                        if (typeof item.attachments != 'undefined') {
                            for (var j = 0; j < item.attachments.length; j++) {
                                attachments.push(item.attachments[j]);
                                //debug(item.attachments[j]);
                            }
                        }
                    }
                }

                for (var uid in self.data.messagesHistory) {
                    var historyMsgData = self.data.messagesHistory[uid];
                    for (var i = 1; i < historyMsgData.length; i++) {
                        var item = historyMsgData[i];
                        if (typeof item.attachments != 'undefined') {
                            for (var j = 0; j < item.attachments.length; j++) {
                                attachments.push(item.attachments[j]);
                                //debug(item.attachments[j]);
                            }
                        }
                    }
                }
            }

            for (var i in self.data.newsfeed.items) {
                var item = self.data.newsfeed.items[i];
                if (typeof item.attachments != 'undefined') {
                  for (var j = 0; j < item.attachments.length; j++) {
                    attachments.push(item.attachments[j]);
                    //debug(item.attachments[j]);
                  }
                }
            }

            for (var j = 0, length = attachments.length; j < length; j++) {
              if (typeof attachments[j].type != 'undefined') {
                var attachmentData = attachments[j][attachments[j].type];
                switch (attachments[j].type) {
                    case 'video':
                        if (typeof self.data.media.video[attachmentData.owner_id + '_' + attachmentData.vid] == 'undefined')
                            mediaMids.video.push(attachmentData.owner_id + '_' + attachmentData.vid);
                        break;
                    case 'audio':
                        if (typeof self.data.media.audio[attachmentData.owner_id + '_' + attachmentData.aid] == 'undefined')
                            mediaMids.audio.push(attachmentData.owner_id + '_' + attachmentData.aid);
                        break;

                }
              } else {
                if (Storage.getPref('logErrors')) {
                  log('notice.strangeAttachment');
                  debug(attachment);
                }
              }
            }

            if (mediaMids.video.length) {
                DataLoader.addApiQuery({
                    code : 'API.video.get({videos:"' + mediaMids.video.join(',') + '"})',
                    handler : function(video){
                        //debug(data);
                        for (var i = 0; i < video.length; i++) {
                            var item = video[i];
                            if (typeof item == 'object') {
                                self.data.media.video[item.owner_id + '_' + item.vid] = item;
                            }
                        }
                    }
                })
            }

            if (mediaMids.audio.length) {
                DataLoader.addApiQuery({
                    code : 'API.audio.getById({audios:"' + mediaMids.audio.join(',') + '"})',
                    handler : function(audio){
                        for (var i = 0; i < audio.length; i++) {
                            var item = audio[i];
                            if (typeof item == 'object') {
                                self.data.media.audio[item.owner_id + '_' + item.aid] = item;
                            }
                        }
                    }
                })
            }
        },
        getProfilesData: function() {
            var profiles = [];
            profiles[VkApiParams.userId] = true;
            for (var i = 1; i < self.data.messages.length; i++) {
                var item = self.data.messages[i];
                profiles[item.uid] = true;
            }
            for (var i = 1; i < self.data.posts.length; i++) {
                var item = self.data.posts[i];
                profiles[item.from_id] = true;
            }
            if (self.data.postComments) {
                for (var i in self.data.postComments) {
                    for (var j = 1; j < self.data.postComments[i].length; j++) {
                        profiles[self.data.postComments[i][j].uid] = true;
                    }
                }
            }
            var profileIds = [];
            for ( var id in self.data.profiles ) {
                if ( typeof profiles[id] == 'undefined' ) {
                    delete self.data.profiles[id];
                } else {
                    delete profiles[id];
                }
            }
            for ( var id in profiles ) {
                profileIds.push(id);
            }

            if (profileIds.length) {
                DataLoader.addApiQuery({
                    code : 'API.getProfiles({"uids" : [' + profileIds.join(',') + '], "fields" : "photo"})',
                    handler : function(profilesData){
                        profiles = [];
                        for (var i = 0; i < profilesData.length; i++) {
                            self.data.profiles[profilesData[i].uid] = profilesData[i];
                        }
                        //self.data.profiles = profiles;
                    }
                })
            }
        },
        getWallAndMessagesData: function() {
            var self = this;
            DataLoader.addApiQuery({
                code : 'API.messages.' + ( Storage.getPref('messagesAsDialogs') ? 'getDialogs' : 'get' ) + '({count : "' + MESSEGES_COUNT + '", preview_length : "0"})',
                handler : function(messages){
                    self.data.messages = messages;
                }
            });
            DataLoader.addApiQuery({
                code : 'API.wall.get({count : "' + POSTS_COUNT + '"})',
                handler : function(posts){
                    self.data.posts = posts;
                }
            });
        },
        getMessagesHistory : function() {
            var self = this;
            for (var i = 1; i < self.data.messages.length; i++) {
                if ((self.firstRun) || (self.userChanged) || ( parseInt( Storage.getValue('messagesChangetime')) < self.data.messages[ i ].date ) || (typeof self.data.messagesHistory[self.data.messages[i]['uid']] == 'undefined' ) ) {
                    DataLoader.addApiQuery(
                        (function(uid){
                            return {
                                code : 'API.messages.getHistory({uid: "' + uid + '",count : "' + MESSAGE_HISTORY_COUNT + '"})',
                                handler : function(response){
                                    self.data.messagesHistory[uid] = response;
                                    //echo('zzz');
                                }
                            }
                        })(self.data.messages[i]['uid'])
                        )

                        }
                    }
        },
        getPostCommentsData: function(type) {
            var self = this;
            for (var i = 1; i < self.data.posts.length; i++) {
                if (typeof self.tabs.wall.children[i - 1] == 'undefined' ? self.data.posts[i].comments.count: self.data.posts[i].comments.count != self.tabs.wall.children[i - 1].getAttribute('data-comments-count')) {
                    DataLoader.addApiQuery(
                        (function(i){
                            return {
                                code : 'API.wall.getComments({post_id: "' + self.data.posts[i].id + '", count : "100" })',
                                handler : function(response){
                                    //log('WATCHME : ' + response);
                                    self.data.postComments[self.data.posts[i].id] = response;
                                }
                            }
                        })(i)
                    )
                }
            }

            for (var i in self.data.newsfeed.items) {
                var item = self.data.newsfeed.items[i];
                if (item.type == 'post') {
                    DataLoader.addApiQuery(
                        (function(postId){
                            return {
                                code : 'API.wall.getComments({ owner_id: "'+item.source_id+'",  post_id: "' + postId + '", sort : "desc", count : "3" })',
                                handler : function(response){
                                    response = response || [];
                                    response.reverse();
                                    response.unshift(response.pop());
                                    self.data.postComments[postId] = response;
                                }
                            }
                        })(item.post_id)
                    )
                }
            }

        },
        getCommentsData: function(handler) {
            var self = this;
            if (!Storage.getPref('notify.comments')) {
                handler();
                return;
            }
            DataLoader.request('http://' + Storage.getPref('server') + '/al_feed.php', {
                al: 1,
                section: 'comments',
                timestamp: Storage.getValue('commentsLastTimestamp')
            },
            function(data) {
                data = DataLoader.parseVkResult(data);
                var optionsTimestamp = 0;
                var timestamp = 0;
                if (data.length > 1) {
                    for (var i in data) {
                        if ((typeof data[i] === 'string') && (data[i].indexOf('div') != - 1)) {
                            self.data.comments = data[i];
                        } else if ((data[i]) && (typeof data[i] == 'object') && (typeof data[i].timestamp != 'undefined')) {
                            optionsTimestamp = data[i].timestamp;
                        } else if ((typeof data[i] == 'number') && (/1\d{9}/.test(data[i]))) {
                            timestamp = data[i];
                        }
                    }
                }
                if ((timestamp < parseInt(Storage.getValue('commentsLastTimestamp'))) || (optionsTimestamp < parseInt(Storage.getValue('commentsLastTimestamp')))) {
                    self.data.comments = '';
                } else {
                    Storage.setValue('commentsLastTimestamp', optionsTimestamp);
                }
                handler();
            })
        },

        getOtherData: function(handler) {
            var self = this;
            DataLoader.request('http://' + Storage.getPref('server') + '/feed2.php', null, function(data) {
                //log(data);
                var itemTypeNames = ['friends', 'events', 'groups', 'photos', 'videos'];
                try {
                    var feedParsed = parseJson(data, true);
                } catch(e) {
                    if (Storage.getPref('logErrors')) {
                        log(e + '; url == ' + 'http://' + Storage.getPref('server') + '/feed2.php' + '; data == ' + data);
                    }
                    self.makeLogin();
                    return;
                }
                for (var i in itemTypeNames) {
                    if (typeof feedParsed[itemTypeNames[i]] != 'undefined') {
                        self.data.other[itemTypeNames[i]] = feedParsed[itemTypeNames[i]].count;
                    }
                }
                if (typeof feedParsed['user'] != 'undefined') {
                    self.data.other['userId'] = feedParsed['user'].id;
                }
                if (typeof feedParsed['messages'] != 'undefined') {
                    self.data.other['unreadMessages'] = feedParsed['messages'].count;
                }
                handler();
            });
        },
        getAllData: function() {
            var self = this;
            self.dataRequestLocalTime = currentUnixTime();
            DataLoader.apiQueryQueue = [];
            //DataLoader.addApiQuery({
            //code : 'API.getAds()',
            //handler : function(data) {
            //debug(data);
            //}
            //});
            //DataLoader.addApiQuery({
            //code : 'API.getServerTime()',
            //handler : function(unixtime) {
            //self.dataRequestServerTime = unixtime;
            //if (self.firstRun || self.userChanged) {
            //Storage.setValue('commentsLastTimestamp', (unixtime - 1 * 24 * 60 * 60));
            //}
            //}
            //});
            self.getWallAndMessagesData();
            self.getNewsfeedData();
            DataLoader.proceedAll(function(){
                //debug(self.data.postComments);
                self.getPostCommentsData();
                self.getMessagesHistory();
                DataLoader.proceedAll(function(){
                    self.getMediaData();
                    self.getProfilesData();
                    self.getFriendsData();
                    DataLoader.proceedAll(function(){
                        self.getCommentsData(function() {
                            self.getOtherData(
                                function() {
                                    Event.notify('dataLoaded');
                                });
                        });
                    });

                });
            });
        },
		makeLogin: function() {
			var self = this;
            if (Storage.getPref('logErrors')) {
                log('notice.makeLogin; time = ' + currentUnixTime());
            }
			clearTimeout(self.retryId);
			clearTimeout(self.relogId);
            clearTimeout(self.updatePeriodId);
			clearInterval(self.checkLifecycleId);
			self.setState('offline');
			show(self.loginBoxWrapNode);
			//hide(self.loginBoxNode);
			self.loginBoxNode.className += ' hidden';
			var progressBoxNode = self.loginBoxWrapNode.querySelector('.progress-box');
			show(progressBoxNode);
			show(self.mainboxBodyOverlayNode);
			self.oldLocation = 'http://' + Storage.getPref('server') + '/login.php?' + self.loginParams;
			self.loginBoxNode.removeAttribute('src');
			self.loginBoxNode.setAttribute('src', self.oldLocation);
            self.mainboxNode.querySelector('.title').textContent = 'VKfox';
			var makeRelogin = function() {
				if (self.popupPanelNode.state != 'open') {
					self.makeLogin();
				} else {
					clearTimeout(self.relogId);
					self.relogId = setTimeout(
					makeRelogin, RELOG_TIME);
				}
			}
			self.relogId = setTimeout(
			makeRelogin, RELOG_TIME);
		},
		initToolbarbutton: function() {
			var self = this;
			self.toolbarbutton = document.getElementById('vkfox-toolbarbutton');
			if (self.toolbarbutton) {
				try {
					var isLinux = /linux/i.test(Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS);
				} catch(e) {
					if (Storage.getPref('logErrors')) {
						log('error.isLinux; e = ' + e);
					}
					isLinux = false;
				}
				if (isLinux) {
					if (self.toolbarbutton.parentNode.getAttribute('iconsize') == 'small') {
						self.toolbarButtonDemension = 16;
					} else {
						self.toolbarButtonDemension = 24;
					}
				} else {
					self.toolbarButtonDemension = 18;
				}
				self.toolbarbutton.onclick = function(event) {
					self.popupPanelAnchor = 'toolbar';
					if (event.which == 1) {
						self.showPopupPanel();
					}
					//return false;
				};
				self.setState();
				self.displayUpdatesInfo();
			}
		},
		addToolbarButton: function() {
			try {
				var myId = "vkfox-toolbarbutton"; // ID of button to add
				var afterId = "search-container"; // ID of element to insert after
				var navBar = document.getElementById("nav-bar");
				var curSet = navBar.currentSet.split(",");

				if ((curSet.indexOf(myId) == - 1) && (true)) {
					var pos = curSet.indexOf(afterId) + 1 || curSet.length;
					var set = curSet.slice(0, pos).concat(myId).concat(curSet.slice(pos));

					navBar.setAttribute("currentset", set.join(","));
					navBar.currentSet = set.join(",");
					document.persist(navBar.id, "currentset");
					try {
						BrowserToolboxCustomizeDone(true);
					} catch(e) {
						log(e);
					}
				}
			} catch(e) {
				log(e);
			}
		}
	}
	var Draggable = function(id) {}
	Draggable.prototype = {}
	var retriesToStart = 0;
	var init = function() {
		setTimeout(

		function() {
			if ((window.toolbar.visible != false)) {
				window.removeEventListener("load", init, true);
				/*
                    * crunch for "Organize StatusBar" plugin
                    */

				try {
					vkfox = new Vkfox();
				} catch(e) {
					//don't retry if globalStorage['vkfox'] is off
					if ((e.name != 'NS_ERROR_DOM_SECURITY_ERR') && (retriesToStart++ < MAX_RETRIES_TO_START)) {
						init();
					}
					log(e);
					return;
				}
				if (globalStorage['vkfox']['enabled'] == '1') {
					vkfox.makeLogin();
				}
			} else {}
		},
		1000);
	}
	window.addEventListener("load", init, true);
	window.getVkfoxExtensionInstance = function() {
		return vkfox;
	}
})();
